function utrl_someTimeConsumingOperation(millisecond=1000) {
  // 模拟耗时操作
  const start = Date.now();
  while (Date.now() - start < millisecond) {} // 等待1秒
  console.log("耗时"+millisecond/1000+"秒的操作完成");
}

function util_getscript_pageData_content(html=''){
    // 示例HTML代码
    // 正则表达式匹配<script>标签内容的模式
    var scriptTagPattern = /<script\b[^>]*>([\s\S]*?)<\/script>/gm;
    var matches = html.match(scriptTagPattern);
    if (matches) {
        for (var i = 0; i < matches.length; i++) {
            // 提取<script>标签里的内容
            var scriptContent = matches[i].replace(scriptTagPattern, '$1');
            if(scriptContent.indexOf('window.pageData') !=-1 && scriptContent.indexOf('sellerName') !=-1){
               return scriptContent;
            }
        }
    }
    return false;
}

function util_ajax_get(url=''){
    console.log('url:'+url);
    let _html_result = '';
    var exhibitors_ajax = $.ajax({
             //url: 'https://www.google.com/maps/place/VIP+Wigs+%26+Prosthesis/@37.9009282,-122.0623831,17z/data=!3m1!4b1!4m6!3m5!1s0x808561953bedbbfd:0xe9365860131da46b!8m2!3d37.9009282!4d-122.0623831!16s%2Fg%2F1tcxpx4r?authuser=0&hl=en',
             url:url,
             xhrFields: {
               withCredentials: true
             },
             data: {},
             type: 'GET',
             async:false,
             crossDomain: true,
             //timeout:20000,//20 s
             dataType: 'html',
             //contentType:'text/html; charset=utf-8',
             //dataType: 'json',
             contentType:'application/json;charset=utf-8',
             success: function(data) {
                 _html_result = data;
             },
             error: function(xhr, textStatus, errorThrown) {
                _html_result = 'error';
            }
         });
    return _html_result;
}
//搜索页及类目页采集
function shangjia_search_caiji(){
    setTimeout(function (){
        var message = {
            action: 'can_list_caiji',
            info: ''
        };
        chrome.runtime.sendMessage(message,(msg)=>{
            console.log('can_list_caiji 答复',msg)
            let msgobj  = JSON.parse(msg);
            console.log(msgobj['state']);
            if(msgobj['state'] == 0){ //可以自动采集
                console.log('list采集已开启 1');
                //
                console.log('shangjia_search_caiji 1');
                let current_url = window.location.href;
                if(current_url) {
                    if (current_url.indexOf('keyword/?q=') != -1 || current_url.indexOf('/c/') != -1 || (current_url.indexOf('?q=') != -1 && current_url.indexOf('store') != -1)) {
                        //
                        let scriptdata = util_getscript_pageData_content($("html").html());
                        if (scriptdata) {
                            scriptdata = scriptdata.trim();
                            //
                            let _scriptdata_arr = scriptdata.split('window.pageData =');
                            let _scriptdata2 = _scriptdata_arr[1];
                            let _scriptdata_arr3 = _scriptdata2.split('window.uspData =');
                            scriptdata = _scriptdata_arr3[0];
                            scriptdata = scriptdata.trim();
                            scriptdata = scriptdata.slice(0,-1);
                            //
                            console.log('scriptdata');
                            console.log(scriptdata);

                            let scriptdata_json = JSON.parse(scriptdata);
                            console.log('scriptdata_json');
                            console.log(scriptdata_json);
                            //
                            var shangjia_infos = [];
                            let listItems = scriptdata_json['mods']['listItems'];
                            for(let _item_key in listItems){
                               let _item_data = listItems[_item_key];
                               //console.log('_item_data');
                               //console.log(_item_data);
                               //
                               let _shangjia_name =  _item_data['name'];
                               let _shangjia_a_link = _item_data['itemUrl'];
                               _shangjia_a_link = _shangjia_a_link.replace('//','https://');
                               let _shangjia_id = _item_data['itemId'];
                               let _shangjia_sold = _item_data['itemSoldCntShow'];
                               if(_shangjia_sold){
                                   _shangjia_sold = _shangjia_sold.replace('sold','');
                                   _shangjia_sold = _shangjia_sold.trim();
                                   _shangjia_sold = parseInt(_shangjia_sold);
                               }
                               let _shangjia_price = _item_data['price'];
                               if(_shangjia_price){
                                   _shangjia_price = parseFloat(_shangjia_price);
                               }
                               let _shangjia_old_price = _item_data['originalPrice'];
                               if(_shangjia_old_price){
                                   _shangjia_old_price = parseFloat(_shangjia_old_price);
                               }
                               let _shangjia_reivew_num = _item_data['review'];
                               let _shangjia_review_score = _item_data['ratingScore'];
                                if(_shangjia_review_score){
                                    _shangjia_review_score = parseFloat(_shangjia_review_score);
                                    _shangjia_review_score = _shangjia_review_score.toFixed(2);
                                }
                                let _shangjia_sellerName = _item_data['sellerName'];
                                let _shangjia_sellerId = _item_data['sellerId'];
                                //https://www.miravia.es/cl/store/profile?sellerKey=ofertones-selecionados
                                let _shangjia_sellerKey = _shangjia_sellerName;
                                if(_shangjia_sellerKey){
                                    _shangjia_sellerKey = _shangjia_sellerKey.toLowerCase();
                                    _shangjia_sellerKey = _shangjia_sellerKey.replace(' ','-');
                                }
                                let _shangjia_profile_url = "https://www.miravia.es/cl/store/profile?sellerKey="+_shangjia_sellerKey;
                                //
                                let _shangjia_img = _item_data['image'];
                                //
                                let _shangjia_brand = _item_data['brandName'];
                                //
                                let _shangjia_first_order_price = '';
                                let _expression = _item_data['expression'];
                                if(_expression.hasOwnProperty('tags')){
                                    let _expression_tags = _expression['tags'];
                                    if(_expression_tags.length > 0){
                                        let _tag_data = _expression_tags[_expression_tags.length-1];
                                        _shangjia_first_order_price = _tag_data['customValue']['afterCouponPriceIntegerPart'] + _tag_data['customValue']['afterCouponPriceDecimalPart'];
                                    }
                                }
                                //
                               let _shangjia_info = {
                                    '_shangjia_id': _shangjia_id,
                                    '_shangjia_name': _shangjia_name,
                                    '_shangjia_a_link':_shangjia_a_link,
                                    '_shangjia_img': _shangjia_img,
                                    '_shangjia_price': _shangjia_price,
                                    '_shangjia_old_price': _shangjia_old_price,
                                    '_shangjia_first_order_price':_shangjia_first_order_price,
                                    '_shangjia_review_score': _shangjia_review_score,
                                    '_shangjia_reivew_num': _shangjia_reivew_num,
                                    '_shangjia_sold':_shangjia_sold,
                                    '_shangjia_sellerId':_shangjia_sellerId,
                                    '_shangjia_sellerName':_shangjia_sellerName,
                                    '_shangjia_profile_url':_shangjia_profile_url,
                                    '_shangjia_brand':_shangjia_brand
                               };
                               //console.log(_shangjia_info);
                               shangjia_infos.push(_shangjia_info);
                            }
                            //
                        }
                        //
                        var message = {
                            action: 'shangjia_items_update',
                            info: '',
                            shangjia_infos: shangjia_infos
                        };
                        send_message_to_popup(message);
                        //
                        //处理自动化采集
                        //处理自动化采集
                        let _next_href = $("div[class*='pagination'] li[class*='next'] a").attr('href');
                        //
                        let _lasted_page_num = $("div[class*='pagination'] li:eq(-2) a").attr('title');
                        console.log('_lasted_page_num');
                        console.log(_lasted_page_num);
                        _lasted_page_num = parseInt(_lasted_page_num);

                        let _next_href_arr = _next_href.split('page=');
                        let _next_href_num = _next_href_arr[1];
                        _next_href_num = parseInt(_next_href_num);
                        _next_href_num +=1;
                        console.log('_next_href_num');
                        console.log(_next_href_num);
                        if(_next_href_num <= _lasted_page_num){
                            console.log('_next_href');
                            console.log(_next_href);
                            if(_next_href){
                                setTimeout(function (){
                                    location.href= _next_href;
                               },8000);
                            }
                        }
                        //
                        //
                    }
                }
                //
            }else{
                console.log('list采集已关闭')
            }
        })
    },1000);
}

function shangjia_search_next_caiji(res_data=''){
    if (res_data) {
        let scriptdata_json = JSON.parse(res_data);
        console.log('scriptdata_json');
        console.log(scriptdata_json);
        //
        var shangjia_infos = [];
        let listItems = scriptdata_json['mods']['listItems'];
        for(let _item_key in listItems){
            let _item_data = listItems[_item_key];
            //console.log('_item_data');
            //console.log(_item_data);
            //
            let _shangjia_name =  _item_data['name'];
            let _shangjia_a_link = _item_data['itemUrl'];
            _shangjia_a_link = _shangjia_a_link.replace('//','https://');
            let _shangjia_id = _item_data['itemId'];
            let _shangjia_sold = _item_data['itemSoldCntShow'];
            if(_shangjia_sold){
                _shangjia_sold = _shangjia_sold.replace('sold','');
                _shangjia_sold = _shangjia_sold.trim();
                _shangjia_sold = parseInt(_shangjia_sold);
            }
            let _shangjia_price = _item_data['price'];
            let _shangjia_old_price = _item_data['originalPrice'];
            let _shangjia_reivew_num = _item_data['review'];
            let _shangjia_review_score = _item_data['ratingScore'];
            if(_shangjia_review_score){
                _shangjia_review_score = parseFloat(_shangjia_review_score);
                _shangjia_review_score = _shangjia_review_score.toFixed(2);
            }
            let _shangjia_sellerName = _item_data['sellerName'];
            let _shangjia_sellerId = _item_data['sellerId'];
            //https://www.miravia.es/cl/store/profile?sellerKey=ofertones-selecionados
            let _shangjia_sellerKey = _shangjia_sellerName;
            if(_shangjia_sellerKey){
                _shangjia_sellerKey = _shangjia_sellerKey.toLowerCase();
                _shangjia_sellerKey = _shangjia_sellerKey.replace(' ','-');
            }
            let _shangjia_profile_url = "https://www.miravia.es/cl/store/profile?sellerKey="+_shangjia_sellerKey;
            //
            let _shangjia_img = _item_data['image'];
            //
            let _shangjia_brand = _item_data['brandName'];
            //
            let _shangjia_info = {
                '_shangjia_id': _shangjia_id,
                '_shangjia_name': _shangjia_name,
                '_shangjia_a_link':_shangjia_a_link,
                '_shangjia_img': _shangjia_img,
                '_shangjia_price': _shangjia_price,
                '_shangjia_old_price': _shangjia_old_price,
                '_shangjia_review_score': _shangjia_review_score,
                '_shangjia_reivew_num': _shangjia_reivew_num,
                '_shangjia_sold':_shangjia_sold,
                '_shangjia_sellerId':_shangjia_sellerId,
                '_shangjia_sellerName':_shangjia_sellerName,
                '_shangjia_profile_url':_shangjia_profile_url,
                '_shangjia_brand':_shangjia_brand
            };
            //console.log(_shangjia_info);
            shangjia_infos.push(_shangjia_info);
        }
        //
        var message = {
            action: 'shangjia_items_update',
            info: '',
            shangjia_infos: shangjia_infos
        };
        send_message_to_popup(message);
        //
        //处理自动化采集
        $("div[class*='pagination'] li[class*='next'] a").click();
        //
        //
    }
}

//店铺商品采集
function shangjia_store_items_caiji(){
    setTimeout(function (){
        var message = {
            action: 'can_list_caiji',
            info: ''
        };
        chrome.runtime.sendMessage(message,(msg)=>{
            console.log('can_list_caiji 答复',msg)
            let msgobj  = JSON.parse(msg);
            console.log(msgobj['state']);
            if(msgobj['state'] == 0){ //可以自动采集
                console.log('list采集已开启');
                //
                console.log('shangjia_store_items_caiji');
                let current_url = window.location.href;
                if(current_url) {
                    if (current_url.indexOf('/store/') != -1) {
                        var shangjia_infos = [];
                        let i=1;
                        $("div[st_page_id]").each(function (){
                            console.log('fffff');
                            let _shangjia_a_link = $(this).find('a').attr('href');
                            if(_shangjia_a_link){
                                _shangjia_a_link = _shangjia_a_link.replace('//','https://');
                                let _shangjia_a_link_arr = _shangjia_a_link.split('?');
                                _shangjia_a_link = _shangjia_a_link_arr[0];
                                //
                                _shangjia_a_link_arr = _shangjia_a_link.split('/');
                                let _id_str = _shangjia_a_link_arr[_shangjia_a_link_arr.length-1];
                                _id_str = _id_str.replace('.html','');
                                let _shangjia_id = _id_str;
                                let _shangjia_name = $(this).find('h3').text();
                                _shangjia_name = _shangjia_name.trim();
                                let _shangjia_sold = '';
                                //
                                $(this).find("div").each(function (){
                                   let _div_val = $(this).text();
                                   if(_div_val){
                                       _div_val = _div_val.trim();
                                       if(_shangjia_sold == '' && _div_val.indexOf('sold') !=-1 && _div_val.length < 20 ){
                                            _shangjia_sold = _div_val;
                                            console.log('_shangjia_sold ff');
                                                console.log(_shangjia_sold);
                                            _shangjia_sold = _shangjia_sold.replace(',','').replace('+','').replace('sold','');
                                            _shangjia_sold = _shangjia_sold.trim();
                                            if(_shangjia_sold.indexOf('K')!=-1){
                                                _shangjia_sold = _shangjia_sold.replace('K','');
                                                _shangjia_sold = parseInt(_shangjia_sold);
                                                _shangjia_sold = _shangjia_sold * 1000;
                                            }
                                       }
                                       //
                                   }
                                });
                                //
                                let _shangjia_info = {
                                    '_shangjia_id': _shangjia_id,
                                    '_shangjia_name': '',
                                    '_shangjia_a_link':_shangjia_a_link,
                                    '_shangjia_img': '',
                                    '_shangjia_price': '',
                                    '_shangjia_old_price': '',
                                    '_shangjia_review_score': '',
                                    '_shangjia_reivew_num': '',
                                    '_shangjia_sold':_shangjia_sold
                                };
                                //console.log(_shangjia_info);
                                shangjia_infos.push(_shangjia_info);
                                //
                                if(shangjia_infos.length > 50){
                                    var message = {
                                        action: 'shangjia_items_update',
                                        info: '',
                                        shangjia_infos: shangjia_infos
                                    };
                                    send_message_to_popup(message);
                                    shangjia_infos = [];
                                }
                                //
                                console.log('shangjia_store_items_caiji i:'+i);
                                i++;
                            }
                        });
                        //
                        var message = {
                            action: 'shangjia_items_update',
                            info: '',
                            shangjia_infos: shangjia_infos
                        };
                        send_message_to_popup(message);
                        //
                        //处理自动化采集
                        //zidong_caiji_next();
                        //
                    }
                }
                //
            }else{
                console.log('list采集已关闭')
            }
        })
    },1000);
}

var navigation_url = '';
function perf_observer(list, obserer){
    //console.log('aa');
    //console.log(getNetworkRequests(list.getEntriesByType('resource')));
    performanceResourceList = list.getEntriesByType('resource');
    //console.log(performanceResourceList);
    for(i = 0; i<performanceResourceList.length; i++){
        performanceResourceItem = performanceResourceList[i];
        //console.log('abababa');
        //console.log(performanceResourceItem);
        if(performanceResourceItem['initiatorType'] == 'xmlhttprequest'){
            if(performanceResourceItem['name'].indexOf('keyword/?q=')!=-1 && performanceResourceItem['name'].indexOf('ajax')!=-1){
                //console.log(performanceResourceItem['name']);
                console.log('bbbb'+performanceResourceItem['name']);
                //
                let _search_next_url = performanceResourceItem['name'];
                //shangjia_search_caiji();
                let _res_data = util_ajax_get(_search_next_url);
                //
                console.log('_res_data');
                console.log(_res_data);
                shangjia_search_next_caiji(_res_data);
                //
            }else if(performanceResourceItem['name'].indexOf('r.png?t=api&times=1&page=')!=-1){
                setTimeout(function (){
                    shangjia_store_items_caiji();
                },2000);
            }
        }else if(performanceResourceItem['initiatorType'] == 'script'){
            if(performanceResourceItem['name'].indexOf('mtop.ae.shop.search.product.group')!=-1){
                setTimeout(function (){
                    shangjia_store_items_caiji();
                },2000);
            }
        }
    }
    //////
    /*performanceNavigationList = list.getEntriesByType('navigation');
    for(i = 0; i<performanceNavigationList.length; i++) {
        performanceNavigationItem = performanceNavigationList[i];
        if (performanceNavigationItem['initiatorType'] == 'navigation') {
            navigation_url = performanceNavigationItem['name']
        }
    }*/
}
var observer_ = new PerformanceObserver(perf_observer);
//observer_.observe({entryTypes:['resource', 'navigation']});
//observer_.observe({entryTypes:['resource', 'navigation', 'paint']});
//

$(document).ready(function () {
    setTimeout(function (){
                    shangjia_search_caiji();
                    shangjia_store_items_caiji();
                    //add_export_pingtai_btn();
                },2000);
    setTimeout(function() {
        shangjia_new_tab_process_item_step2();
        //shangjia_new_tab_process_item_step2_you();
        //export_single_();
        //export_single_you();
     }, 2000);
});

//send message to pop
function send_message_to_popup(message={}){
    /*
    {
            action: 'extract-catalog-products-export-clean',
            info: ''
        }
     */
    console.log('message');
    console.log(message);
    chrome.runtime.sendMessage(message,(msg)=>{
        console.log('答复',msg)
    })
}
//
function downloadIamge(imgsrc, name){//下载图片地址和图片名
    let image = new Image();
    // 解决跨域 Canvas 污染问题
    image.setAttribute("crossOrigin", "anonymous");
    image.onload = function() {
        let canvas = document.createElement("canvas");
        canvas.width = image.width;
        canvas.height = image.height;
        let context = canvas.getContext("2d");
        context.drawImage(image, 0, 0, image.width, image.height);
        let url = canvas.toDataURL("image/jpeg"); //得到图片的base64编码数据
        let a = document.createElement("a"); // 生成一个a元素
        let event = new MouseEvent("click"); // 创建一个单击事件
        a.download = name || "photo"; // 设置图片名称
        a.href = url; // 将生成的URL设置为a.href属性
        a.dispatchEvent(event); // 触发a的单击事件
    }
    image.src = imgsrc;
}
//
function get_product_lunbo_imgs(){
    console.log('aaaa');
    //
    let _shangjia_gallery = [];
    $("div[class*='slider--wrap'] div[class*='slider--img']").each(function (){
        let _img = $(this).find('img').attr('src');
        if(_img){
            _img = _img.replace('_80x80.jpg_.webp','');
            _shangjia_gallery.push(_img);
        }
    });
    if(_shangjia_gallery.length>0){
        for (let _i = 0; _i < _shangjia_gallery.length; _i++) {
            let _img = _shangjia_gallery[_i];
            let _img_src = _img;
            let _imgarr = _img.split('/');
            let _img_name = _imgarr[_imgarr.length-1];
            let _img_name_arr = _img_name.split('.');
            _img_name = _img_name_arr[0];
            _img_name = _img_name+'_'+(_i+1);
            //
            downloadIamge(_img_src,_img_name);
        }
    }
    //
}
//
function get_product_details_imgs() {
    console.log('aaaa');
    //
    let _shangjia_productDetailFlatList = [];
    $('#product-description img').each(function () {
        let _desc_img = $(this).attr('src');
        console.log('_desc_img:' + _desc_img);
        if (_desc_img.indexOf('.gif') != -1) {
            _desc_img = $(this).attr('data-src');
            console.log('_desc_img 2:' + _desc_img);
            if (typeof _desc_img === 'undefined') {
                _desc_img = $(this).attr('data-ks-lazyload');
                console.log('_desc_img 3:' + _desc_img);
            }
        }
        _shangjia_productDetailFlatList.push(_desc_img);
    });
    //
    if (_shangjia_productDetailFlatList) {
        for (_j = 0; _j < _shangjia_productDetailFlatList.length; _j++) {
            let _img = _shangjia_productDetailFlatList[_j];
            let _img_src = _img;
            let _imgarr = _img.split('/');
            let _img_name = _imgarr[_imgarr.length - 1];
            let _img_name_arr = _img_name.split('.');
            _img_name = _img_name_arr[0];
            _img_name ='_detail_' + _img_name+'_'+(_j+1);
            //
            downloadIamge(_img_src, _img_name);
        }
    }
    //
}
//
function extract_products_lunbo_imgs(galleryimgs){
    console.log('extract_products_lunbo_imgs');
    console.log(galleryimgs);
    for(let i=0;i<galleryimgs.length;i++){
        downloadIamge(galleryimgs[i]['url'], galleryimgs[i]['name']);
    }
}

function extract_products_detail_imgs(detailsimgs){
    console.log('extract_products_detail_imgs');
    console.log(detailsimgs);
    for(let i=0;i<detailsimgs.length;i++){
        downloadIamge(detailsimgs[i]['url'], detailsimgs[i]['name']);
    }
}

function util_getscript_g_config_content(html=''){
    // 示例HTML代码
    // 正则表达式匹配<script>标签内容的模式
    var scriptTagPattern = /<script\b[^>]*>([\s\S]*?)<\/script>/gm;
    var matches = html.match(scriptTagPattern);
    if (matches) {
        for (var i = 0; i < matches.length; i++) {
            // 提取<script>标签里的内容
            var scriptContent = matches[i].replace(scriptTagPattern, '$1');
            if(scriptContent.indexOf('var g_config = {') !=-1){
               return scriptContent;
            }
        }
    }
    return false;
}

function util_currentpage_scrollToBottomWithCallback(callback) {
    var start = window.pageYOffset; // 当前滚动位置
    var end = document.documentElement.scrollHeight - window.innerHeight; // 滚动到底部

    var duration = 8000; // 8 秒
    var startTime = null;

    function scroll(time) {
        if (!startTime) {
            startTime = time;
        }
        var progress = (time - startTime) / duration;
        if (progress > 1) {
            progress = 1;
        }
        var newPosition = start + (end - start) * progress;
        window.scrollTo(0, newPosition);

        if (progress < 1) {
            requestAnimationFrame(scroll);
        } else {
            // 滚动完成后执行回调
            callback();
        }
    }
    requestAnimationFrame(scroll);
}

function util_get_attr_name_value(productSKUPropertyList=[],_attr_name_id='',_attr_value_id=''){
    let _attr_name = ''
    let _attr_value_name = '';
    let _attr_img = '';
    if(_attr_value_id.indexOf('#')!=-1){
        let _attr_value_id_arr = _attr_value_id.split('#');
        _attr_value_id = _attr_value_id_arr[0];
    }
    for (let i=0;i<productSKUPropertyList.length;i++){
        if(productSKUPropertyList[i]['skuPropertyId'] == _attr_name_id){
            _attr_name = productSKUPropertyList[i]['skuPropertyName'];
            let skuPropertyValues = productSKUPropertyList[i]['skuPropertyValues'];

            for(let j=0;j<skuPropertyValues.length;j++){
                //
                if(_attr_value_id == skuPropertyValues[j]['propertyValueId']){
                    let _skuPropertyValue = skuPropertyValues[j];
                    if(_skuPropertyValue.hasOwnProperty('skuPropertyImagePath')){
                        _attr_img = skuPropertyValues[j]['skuPropertyImagePath'];
                    }
                    _attr_value_name = skuPropertyValues[j]['propertyValueDisplayName'];
                    break;
                }
                //
            }
            break;
        }
    }
    return {
        '_attr_name':_attr_name,
        '_attr_value_name':_attr_value_name,
        '_attr_img':_attr_img
    }
}

function util_get_attr_name_value_format(productSKUPropertyList=[],_attr_name_id='',_attr_value_id=''){
    let _attr_name = ''
    let _attr_value_name = '';
    let _attr_img = '';
    if(_attr_value_id.indexOf('#')!=-1){
        let _attr_value_id_arr = _attr_value_id.split('#');
        _attr_value_id = _attr_value_id_arr[0];
    }
    for (let i=0;i<productSKUPropertyList.length;i++){
        if(productSKUPropertyList[i]['skuPropertyId'] == _attr_name_id){
            _attr_name = productSKUPropertyList[i]['skuPropertyName'];
            let skuPropertyValues = productSKUPropertyList[i]['skuPropertyValues'];

            for(let j=0;j<skuPropertyValues.length;j++){
                //
                if(_attr_value_id == skuPropertyValues[j]['propertyValueIdLong']){
                    let _skuPropertyValue = skuPropertyValues[j];
                    if(_skuPropertyValue.hasOwnProperty('skuPropertyImagePath')){
                        _attr_img = skuPropertyValues[j]['skuPropertyImagePath'];
                    }
                    _attr_value_name = skuPropertyValues[j]['propertyValueDisplayName'];
                    break;
                }
                //
            }
            break;
        }
    }
    return {
        '_attr_name':_attr_name,
        '_attr_value_name':_attr_value_name,
        '_attr_img':_attr_img
    }
}

function util_getCurrentUrlQueryStringParams() {
    // 获取当前URL的查询字符串部分
    var queryString = window.location.search;
    if(queryString){
        queryString = queryString.replace('#nav-review','');
    }
    var params = {};
    // 移除开头的问号
    queryString = queryString.substring(1);
    // 分割成键值对数组
    var keyValuePairs = queryString.split('&');
    // 遍历键值对数组，将每一对分割成键和值，并存入params对象
    keyValuePairs.forEach(function(keyValuePair) {
        var pair = keyValuePair.split('=');
        var key = decodeURIComponent(pair[0]);
        var value = decodeURIComponent(pair[1] || '');
        params[key] = value;
    });
    return params;
}

function shangjia_new_tab_process_item_step2(){
    let query_params = util_getCurrentUrlQueryStringParams();
    if(query_params.hasOwnProperty('_shangjia_about_contact_and_basic_info_link_key')){
        $('#gycharm-custom-msg').remove();
        $('body').append("<div id='gycharm-custom-msg' style='font-size: 26px;font-weight: bolder;text-align: center;'>正在采集，30秒采集一个。如果长时间未动，可以尝试刷新该页面！如遇到验证码请及时验证。</div>");
        //
        let current_url = window.location.href;
        let current_url_arr = current_url.split('?');
        let _shangjia_about_contact_and_basic_info_link = current_url_arr[0];
        //
        let performanceData  = null;
        try{
            performanceData = window.performance;
        }catch  (error) {
            console.error("iframePerformance:", error);
        }
        if (performanceData!==null) {
            // 变量已定义
            // 获取网络请求条目
            let resources = performanceData.getEntriesByType('resource');
            // 筛选出类型为 script 且 src 包含特定字符串的条目
            let targetScripts = resources.filter(resource =>
                resource.initiatorType === "xmlhttprequest" &&
                resource.name.includes("mtop.arise.shop.navigation.profilebasic.query")
            );
            //
            console.log('targetScripts');
            console.log(targetScripts);
            //
            // 获取并输出每个符合条件的 script 资源的内容
            targetScripts.forEach(script => {
                fetch(script.name,{ credentials: 'include' })
                    .then(response => response.text())
                    .then(content => {
                        console.log(`Content of script ${script.name}:`);
                        //
                        let runParamscript = content;
                        //
                        let runParamscript_data_json = JSON.parse(runParamscript);
                        console.log(runParamscript_data_json);
                        let runParamscript_json = runParamscript_data_json;
                        if(runParamscript_json){
                            //
                            let need_item = {
                                '_shangjia_about_contact_and_basic_info_link_key':query_params['_shangjia_about_contact_and_basic_info_link_key'],
                                '_shangjia_company_name':'',
                                '_shangjia_company_address':'',
                                '_shangjia_company_vatNumber':'',
                                '_shangjia_shopinfoimage':''
                                //
                            };
                            let _data_result = runParamscript_data_json['data']['result'];
                            if(_data_result){
                                if(JSON.stringify(_data_result) !== '{}'){
                                    let _shangjia_company_name = runParamscript_data_json['data']['result']['license']['companyName'];
                                    let _shangjia_company_address = runParamscript_data_json['data']['result']['license']['address'];
                                    let _shangjia_company_vatNumber = runParamscript_data_json['data']['result']['license']['vatNumber'];
                                    let _shangjia_shopinfoimage = runParamscript_data_json['data']['result']['shopInfo']['shopInfoImages']['en'];
                                    need_item = {
                                            '_shangjia_about_contact_and_basic_info_link_key':query_params['_shangjia_about_contact_and_basic_info_link_key'],
                                            '_shangjia_company_name':_shangjia_company_name,
                                            '_shangjia_company_address':_shangjia_company_address,
                                            '_shangjia_company_vatNumber':_shangjia_company_vatNumber,
                                            '_shangjia_shopinfoimage':_shangjia_shopinfoimage
                                            //
                                    };
                                }
                            }
                            //
                            //export csv
                            console.log('need_item');
                            console.log(need_item);
                            // 在新标签页中打开指定的 URL
                            var message = {
                                action: 'shangjia_new_tab_process_item_step2_complete',
                                info: '',
                                shangjia_info:need_item
                            };
                            //
                            console.log('message');
                            console.log(message);
                            chrome.runtime.sendMessage(message,(msg)=>{
                                    console.log('答复',msg)
                                    //let msgobj = JSON.parse(msg);
                                    //
                                    var message = {
                                        action: 'closeTab',
                                        info: ''
                                    };
                                    send_message_to_popup(message);
                                    //
                            })
                            //
                        }
                        //
                    })
                    .catch(error => {
                        console.error(`Failed to fetch script ${script.name}:`, error);
                        setTimeout(function() {
                                        location.reload();
                                    }, 30000);
                    });
            });
            //
            setTimeout(function() {
                                        location.reload();
                                    }, 30000);
            //
        }
    }
}

function shangjia_new_tab_process_item_step2_you(){
    let query_params = util_getCurrentUrlQueryStringParams();
    if(query_params.hasOwnProperty('_shangjia_about_contact_and_basic_info_link_key')){
        $('#gycharm-custom-msg').remove();
        $('body').append("<div id='gycharm-custom-msg' style='font-size: 26px;font-weight: bolder;text-align: center;'>正在采集，30秒采集一个。如果长时间未动，可以尝试刷新该页面！如遇到验证码请及时验证。</div>");
        //
        let current_url = window.location.href;
        let current_url_arr = current_url.split('?');
        let _shangjia_about_contact_and_basic_info_link = current_url_arr[0];
        //
        let performanceData  = null;
        try{
            performanceData = window.performance;
        }catch  (error) {
            console.error("iframePerformance:", error);
        }
        if (performanceData!==null) {
            // 变量已定义
            // 获取网络请求条目
            let resources = performanceData.getEntriesByType('resource');
            // 筛选出类型为 script 且 src 包含特定字符串的条目
            let targetScripts = resources.filter(resource =>
                resource.initiatorType === "script" &&
                resource.name.includes("mtop.aliexpress.pdp.pc.query")
            );
            // 获取并输出每个符合条件的 script 资源的内容
            targetScripts.forEach(script => {
                fetch(script.name,{ credentials: 'include' })
                    .then(response => response.text())
                    .then(content => {
                        console.log(`Content of script ${script.name}:`);
                        //console.log(content);
                        //
                        let runParamscript = content.replace('mtopjsonp1(','');
                        runParamscript = runParamscript.slice(0,-1);
                        console.log('runParamscript');
                        console.log(runParamscript);
                        //
                        let runParamscript_data_json = JSON.parse(runParamscript);
                        console.log(runParamscript_data_json);
                        let runParamscript_json = runParamscript_data_json['data']['result'];
                        if(runParamscript_json){
                            //
                            let _skus = runParamscript_json['SKU']['skuPaths'];
                            let _item = runParamscript_json['GLOBAL_DATA']['globalData'];
                            let need_item = {
                                    '_shangjia_about_contact_and_basic_info_link_key':query_params['_shangjia_about_contact_and_basic_info_link_key'],
                                    '_shangjia_id': '',
                                    '_shangjia_about_contact_and_basic_info_link': _shangjia_about_contact_and_basic_info_link,

                                    '_shangjia_store_name': '',
                                    '_shangjia_store_url': '',
                                    '_shangjia_store_items': '',
                                    '_shangjia_store_followers': '',
                                    '_shangjia_store_sold': '',
                                    '_shangjia_store_score': '',
                                    //
                                    '_shangjia_goodsId': '', //sku
                                    '_shangjia_variants_skus': [], //数组
                                    '_shangjia_goodsName': '',
                                    '_shangjia_goodsProperty': '',//description,deschtml
                                    '_shangjia_minOnSalePriceStr': '', //最小价格,当没有属性时选择该价格
                                    '_shangjia_hdThumbUrl': '',//主图
                                    '_shangjia_gallery': [], //图片列表
                                    '_shangjia_productDetailFlatList': [],//details imgs
                                    '_shangjia_category': '',//brumb
                                    '_shangjia_VideoUrl': '', //video
                                    '_shangjia_shippingFee':'',
                                    '_shangjia_shippingFee_label':'',
                                    '_shangjia_shipping_Productdelivery':'',
                                    '_shangjia_review_rating':'',
                                    '_shangjia_review_totalValidNum':''
                                    //
                            };
                            let _shangjia_variants_skus = [];
                            if(_skus && _skus.length > 0){
                                let _productSKUPropertyList = runParamscript_json['SKU']['skuProperties'];
                                let skuIdStrPriceInfoMap = runParamscript_json['PRICE']['skuIdStrPriceInfoMap'];
                                if(_productSKUPropertyList.length > 0) {
                                    //
                                    for (let _i = 0; _i < _skus.length; _i++) {
                                        //
                                        if(_skus[_i]['salable'] == false){
                                            continue;
                                        }
                                        //
                                        let specs_key1_name = '';
                                        let specs_key1_value = '';
                                        let specs_key2_name = '';
                                        let specs_key2_value = '';
                                        let specs_key3_name = '';
                                        let specs_key3_value = '';
                                        let specs_key4_name = '';
                                        let specs_key4_value = '';
                                        let _attr_img = '';
                                        //
                                        let skuAttr = _skus[_i]['path'];
                                        let skuAttrArr = skuAttr.split(';');
                                        //
                                        let skuAttrArrLength = skuAttrArr.length;

                                        if (_productSKUPropertyList[_productSKUPropertyList.length - 1]['skuPropertyName'] == "Ships From") {
                                            skuAttrArrLength = skuAttrArrLength - 1;
                                        }
                                        //
                                        if (skuAttrArrLength == 1) {
                                            let _attr_value = skuAttrArr[0];
                                            let _attr_value_arr = _attr_value.split(':');
                                            let _attr_name_id = _attr_value_arr[0];
                                            let _attr_value_id = _attr_value_arr[1];
                                            let attr_name_value_arr = util_get_attr_name_value_format(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key1_name = attr_name_value_arr['_attr_name'];
                                            specs_key1_value = attr_name_value_arr['_attr_value_name'];
                                            if (_attr_img == '' && attr_name_value_arr['_attr_img']) {
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                        } else if (skuAttrArrLength == 2) {
                                            let _attr_value = skuAttrArr[0];
                                            let _attr_value_arr = _attr_value.split(':');
                                            let _attr_name_id = _attr_value_arr[0];
                                            let _attr_value_id = _attr_value_arr[1];
                                            let attr_name_value_arr = util_get_attr_name_value_format(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key1_name = attr_name_value_arr['_attr_name'];
                                            specs_key1_value = attr_name_value_arr['_attr_value_name'];
                                            if (_attr_img == '' && attr_name_value_arr['_attr_img']) {
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                            _attr_value = skuAttrArr[1];
                                            _attr_value_arr = _attr_value.split(':');
                                            _attr_name_id = _attr_value_arr[0];
                                            _attr_value_id = _attr_value_arr[1];
                                            attr_name_value_arr = util_get_attr_name_value_format(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key2_name = attr_name_value_arr['_attr_name'];
                                            specs_key2_value = attr_name_value_arr['_attr_value_name'];
                                            if (_attr_img == '' && attr_name_value_arr['_attr_img']) {
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                        } else if (skuAttrArrLength == 3) {
                                            let _attr_value = skuAttrArr[0];
                                            let _attr_value_arr = _attr_value.split(':');
                                            let _attr_name_id = _attr_value_arr[0];
                                            let _attr_value_id = _attr_value_arr[1];
                                            let attr_name_value_arr = util_get_attr_name_value_format(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key1_name = attr_name_value_arr['_attr_name'];
                                            specs_key1_value = attr_name_value_arr['_attr_value_name'];
                                            if (_attr_img == '' && attr_name_value_arr['_attr_img']) {
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                            _attr_value = skuAttrArr[1];
                                            _attr_value_arr = _attr_value.split(':');
                                            _attr_name_id = _attr_value_arr[0];
                                            _attr_value_id = _attr_value_arr[1];
                                            attr_name_value_arr = util_get_attr_name_value_format(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key2_name = attr_name_value_arr['_attr_name'];
                                            specs_key2_value = attr_name_value_arr['_attr_value_name'];
                                            if (_attr_img == '' && attr_name_value_arr['_attr_img']) {
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                            _attr_value = skuAttrArr[2];
                                            _attr_value_arr = _attr_value.split(':');
                                            _attr_name_id = _attr_value_arr[0];
                                            _attr_value_id = _attr_value_arr[1];
                                            attr_name_value_arr = util_get_attr_name_value_format(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key3_name = attr_name_value_arr['_attr_name'];
                                            specs_key3_value = attr_name_value_arr['_attr_value_name'];
                                            if (_attr_img == '' && attr_name_value_arr['_attr_img']) {
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                        } else if (skuAttrArrLength == 4) {
                                            let _attr_value = skuAttrArr[0];
                                            let _attr_value_arr = _attr_value.split(':');
                                            let _attr_name_id = _attr_value_arr[0];
                                            let _attr_value_id = _attr_value_arr[1];
                                            let attr_name_value_arr = util_get_attr_name_value_format(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key1_name = attr_name_value_arr['_attr_name'];
                                            specs_key1_value = attr_name_value_arr['_attr_value_name'];
                                            if (_attr_img == '' && attr_name_value_arr['_attr_img']) {
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                            _attr_value = skuAttrArr[1];
                                            _attr_value_arr = _attr_value.split(':');
                                            _attr_name_id = _attr_value_arr[0];
                                            _attr_value_id = _attr_value_arr[1];
                                            attr_name_value_arr = util_get_attr_name_value_format(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key2_name = attr_name_value_arr['_attr_name'];
                                            specs_key2_value = attr_name_value_arr['_attr_value_name'];
                                            if (_attr_img == '' && attr_name_value_arr['_attr_img']) {
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                            _attr_value = skuAttrArr[2];
                                            _attr_value_arr = _attr_value.split(':');
                                            _attr_name_id = _attr_value_arr[0];
                                            _attr_value_id = _attr_value_arr[1];
                                            attr_name_value_arr = util_get_attr_name_value_format(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key3_name = attr_name_value_arr['_attr_name'];
                                            specs_key3_value = attr_name_value_arr['_attr_value_name'];
                                            if (_attr_img == '' && attr_name_value_arr['_attr_img']) {
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                            _attr_value = skuAttrArr[3];
                                            _attr_value_arr = _attr_value.split(':');
                                            _attr_name_id = _attr_value_arr[0];
                                            _attr_value_id = _attr_value_arr[1];
                                            attr_name_value_arr = util_get_attr_name_value_format(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key4_name = attr_name_value_arr['_attr_name'];
                                            specs_key4_value = attr_name_value_arr['_attr_value_name'];
                                            if (_attr_img == '' && attr_name_value_arr['_attr_img']) {
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                        }
                                        //
                                        let _skuIdStr = _skus[_i]['skuIdStr'];
                                        let normalPriceStr = skuIdStrPriceInfoMap[_skuIdStr]['salePriceString'];
                                        //
                                        _shangjia_variants_skus.push({
                                            'subsku': _item['productId'] + specs_key1_value + specs_key2_value + specs_key3_value + specs_key4_value,
                                            'normalPriceStr': normalPriceStr,
                                            'normalLinePriceStr': '',
                                            'img': _attr_img,
                                            'specs_key1_name': specs_key1_name,
                                            'specs_key1_value': specs_key1_value,
                                            'specs_key2_name': specs_key2_name,
                                            'specs_key2_value': specs_key2_value,
                                            'specs_key3_name': specs_key3_name,
                                            'specs_key3_value': specs_key3_value,
                                            'specs_key4_name': specs_key4_name,
                                            'specs_key4_value': specs_key4_value,
                                            'stockQuantity': _skus[_i]['skuStock'],
                                            'skuId': _skuIdStr
                                        });
                                        //
                                    }
                                }else{
                                    //没有属性
                                    //
                                    let _skuIdStr = _skus[0]['skuIdStr'];
                                    let normalPriceStr = skuIdStrPriceInfoMap[_skuIdStr]['salePriceString'];
                                    //
                                    _shangjia_variants_skus.push({
                                        'subsku': _item['productId'],
                                        'normalPriceStr': normalPriceStr,
                                        'normalLinePriceStr': '',
                                        'img': '',
                                        'specs_key1_name': '',
                                        'specs_key1_value': '',
                                        'specs_key2_name': '',
                                        'specs_key2_value': '',
                                        'specs_key3_name': '',
                                        'specs_key3_value': '',
                                        'specs_key4_name': '',
                                        'specs_key4_value': '',
                                        'stockQuantity': _skus[0]['skuStock'],
                                        'skuId': _item['productId']
                                    });
                                    //
                                }
                            }
                            //
                            need_item['_shangjia_variants_skus'] = _shangjia_variants_skus;
                            //
                            need_item['_shangjia_goodsId'] = _item['productId'];
                            need_item['_shangjia_goodsName'] = _item['subject'];
                            need_item['_shangjia_minOnSalePriceStr'] = $('.product-price-current').text();
                            //
                            let _shangjia_VideoUrl = '';
                            let _shangjia_gallery = runParamscript_json['HEADER_IMAGE_PC']['imagePathList'];
                            need_item['_shangjia_gallery'] = _shangjia_gallery;
                            if(_shangjia_gallery.length > 0){
                                need_item['_shangjia_hdThumbUrl'] = _shangjia_gallery[0];
                            }
                            need_item['_shangjia_VideoUrl'] = _shangjia_VideoUrl;
                            //
                            need_item['_shangjia_category'] = '';
                            need_item['_shangjia_sold'] = '';
                            need_item['_shangjia_reivew_num'] = '';
                            //
                            let _shangjia_shippingFee = $(".pdp-body-top-right div[class*='shipping--item'] div[class*='shipping--content'] .dynamic-shipping .dynamic-shipping-titleLayout > span:eq(0)").text();
                            need_item['_shangjia_shippingFee'] = _shangjia_shippingFee;
                            //
                            let _shangjia_shippingFee_label = $(".pdp-body-top-right div[class*='shipping--item'] div[class*='shipping--content'] .dynamic-shipping .dynamic-shipping-contentLayout:eq(0)").text();
                            need_item['_shangjia_shippingFee_label'] = _shangjia_shippingFee_label;
                            //
                            let _shangjia_shipping_Productdelivery = $("div[data-pl='product-delivery']").text();
                            if(_shangjia_shipping_Productdelivery){
                                _shangjia_shipping_Productdelivery = _shangjia_shipping_Productdelivery.replace('Ship to','');
                            }
                            need_item['_shangjia_shipping_Productdelivery'] = _shangjia_shipping_Productdelivery;
                            //
                            if(runParamscript_json.hasOwnProperty('PC_RATING')){
                                need_item['_shangjia_review_rating'] = runParamscript_json['PC_RATING']['rating'];
                                need_item['_shangjia_review_totalValidNum'] = runParamscript_json['PC_RATING']['totalValidNum'];
                            }
                            //
                            let sellerComponent = runParamscript_json['SHOP_CARD_PC']
                            let storeURL = sellerComponent['sellerInfo']['storeURL'];
                            storeURL = storeURL.replace('//','https://');
                            need_item['_shangjia_store_name'] = sellerComponent['storeName'];
                            need_item['_shangjia_store_url'] = storeURL;
                            need_item['_shangjia_store_items'] = '';
                            need_item['_shangjia_store_followers'] = '';
                            need_item['_shangjia_store_sold'] = '';
                            need_item['_shangjia_store_score'] = '';
                            need_item['_shangjia_store_country'] = '';
                            need_item['_shangjia_store_opentime'] = '';
                            //
                            let _shangjia_specifications = '';
                            if(runParamscript_json.hasOwnProperty('PRODUCT_PROP_PC')){
                                let productPropComponent = runParamscript_json['PRODUCT_PROP_PC'];
                                if(productPropComponent.hasOwnProperty('showedProps')){
                                    let props = productPropComponent['showedProps'];
                                    if(props.length > 0){
                                        for(let pi=0; pi<props.length; pi++){
                                            _shangjia_specifications+="<div class='specification--prop--RejitI8'><div class='specification--title--UbVeyic'><span>"+props[pi]['attrName']+"</span></div><div class='specification--desc--Mz148Bl'><span>"+props[pi]['attrValue']+"</span></div></div>";
                                        }
                                        _shangjia_specifications = "<div class='specification--list--fiWsSyv'>"+_shangjia_specifications+"</div>";
                                    }
                                }
                            }
                            need_item['_shangjia_specifications'] = _shangjia_specifications;
                            //
                            //
                            let descriptionUrl =  runParamscript_json['DESC']['pcDescUrl'];
                            //
                            let message = {
                                action: 'get_description',
                                url: descriptionUrl
                            };
                            chrome.runtime.sendMessage(message,(msg)=>{
                                console.log('get_description 答复',msg)
                                let msgobj  = JSON.parse(msg);
                                let description_data = msgobj['description'];
                                console.log('description_data');
                                console.log(description_data);
                                //
                                if(description_data){
                                    description_data = '<div>'+description_data+'</div>';
                                    description_data = description_data.replaceAll('(','');
                                    description_data = description_data.replaceAll(')','');
                                    let _description_data_dom = $(description_data);
                                    let _shangjia_productDetailFlatList = [];
                                    _description_data_dom.find('img').each(function () {
                                        _shangjia_productDetailFlatList.push($(this).attr('src'));
                                    })
                                    need_item['_shangjia_productDetailFlatList'] = _shangjia_productDetailFlatList;
                                    //
                                    need_item['_shangjia_goodsProperty'] = description_data.replace(/<a\s+href="[^"]*"/g, '<a href="#"');
                                    //
                                }
                                need_item['_is_request'] = 2;

                                //export csv
                                //export csv
                                console.log('need_item');
                                console.log(need_item);
                                //
                                // 在新标签页中打开指定的 URL
                                var message = {
                                    action: 'shangjia_new_tab_process_item_step2_complete',
                                    info: '',
                                    shangjia_info:need_item
                                };
                                //
                                console.log('message');
                                console.log(message);
                                chrome.runtime.sendMessage(message,(msg)=>{
                                    console.log('答复',msg)
                                    //let msgobj = JSON.parse(msg);
                                    //
                                    var message = {
                                        action: 'closeTab',
                                        info: ''
                                    };
                                    send_message_to_popup(message);
                                    //
                                })
                                //
                                //
                            })
                            //
                        }else{
                            //alert('未获取到数据，请联系客服！');
                             setTimeout(function() {
                                        location.reload();
                                    }, 30000);
                        }
                        //
                    })
                    .catch(error => {
                        console.error(`Failed to fetch script ${script.name}:`, error);
                        setTimeout(function() {
                                        location.reload();
                                    }, 30000);
                    });
            });
        }
    }
}

function shangjia_new_tab_process_item(need_item){
    console.log('shangjia_new_tab_process_item a1');
    //$('body').append("<div id='gycharm-custom-msg' style='font-size: 26px;font-weight: bolder;text-align: center;'>正在采集，30秒采集一个。如果长时间未动，可以尝试刷新该页面！如遇到验证码请及时验证。</div>");
    //
    // 在新标签页中打开指定的 URL
    var message = {
        action: 'open_new_tab',
        info: '',
        need_item: need_item
    };
    send_message_to_popup(message);
    //
}

function process_caiji_tmall_item(){
    console.log('process_caiji_tmall_item s');
    let current_url = window.location.href;
    if(current_url && (current_url.indexOf('shop/xiaomi') != -1)) {
         //
        $('header').hide();
        $('#container').hide();
        $('.ai-seo').hide();
        $('#g_footer').hide();
        $('.footer-copywrite').hide();
        $("div[class*='pc-header--right']").hide();
        $('#gycharm-custom-msg').remove();
        $('body').append("<div id='gycharm-custom-msg' style='font-size: 26px;font-weight: bolder;text-align: center;'>正在采集，30秒采集一个。如果长时间未动，可以尝试刷新该页面！如遇到验证码请及时验证。</div>");
        //
        var message = {
            action: 'caiji_item_get_tmall',
            info: ''
        };
        chrome.runtime.sendMessage(message, (msg) => {
            console.log('process_caiji_tmall_item 答复', msg)
            let msgobj = JSON.parse(msg);
            let need_item = msgobj['need_item'];
            //console.log(msgobj['need_item']);
            if (need_item) {
                shangjia_new_tab_process_item(need_item);
            }else{
                //
                $('#gycharm-custom-msg').remove();
                if(msgobj['status'] == 1){
                    $('body').append("<div id='gycharm-custom-msg' style='font-size: 26px;font-weight: bolder;text-align: center;'>采集已暂停，可以在插件工具里开启后台采集</div>");
                }else{
                    $('body').append("<div id='gycharm-custom-msg' style='font-size: 26px;font-weight: bolder;text-align: center;'>已采集完成</div>");
                }
            }
        })
    }
}

function xintiao(){
    process_caiji_tmall_item();
}
xintiao();
setInterval(xintiao, 20000);

function add_export_pingtai_btn(){
    console.log('add_export_pingtai_btn');
    let current_url = window.location.href;
    // 创建一个按钮元素
    if(current_url.indexOf('/item/')!=-1){
        console.log('add_export_pingtai_btn a1');
         //
         var newNormalButton = $("<button>", {
            text: '通用Excel格式导出', // 按钮文本
            style: "display: block;\n" +
                "    z-index: 999;\n" +
                "    background: #fb7701;\n" +
                "    width: 180px;\n" +
                "    height: 46px;\n" +
                "    margin-top: 20px;\n" +
                "    line-height: 46px;\n" +
                "    color: #FFF;\n" +
                "    font-weight: bold;\n" +
                "    cursor:pointer;\n" +
                "    border-radius: 22px;",
            click: function() {
                export_single('normal');
            } // 点击按钮时执行的函数
         });
         $('.pdp-info-left').append(newNormalButton);
         //
         var newButton = $("<button>", {
            text: '导出Shopify格式', // 按钮文本
            style: "display: block;\n" +
                "    z-index: 999;\n" +
                "    background: #fb7701;\n" +
                "    width: 180px;\n" +
                "    height: 46px;\n" +
                "    margin-top: 10px;\n" +
                "    line-height: 46px;\n" +
                "    color: #FFF;\n" +
                "    font-weight: bold;\n" +
                "    border-radius: 22px;",
            click: function() {
               export_single('shopify');
            } // 点击按钮时执行的函数
        });
        // 将按钮添加到指定的<div>中
        $('.pdp-info-left').append(newButton);
        //
        var newTiktokButton = $("<button>", {
            text: '导出Tiktok格式', // 按钮文本
            style: "display: block;\n" +
                "    z-index: 999;\n" +
                "    background: #fb7701;\n" +
                "    width: 180px;\n" +
                "    height: 46px;\n" +
                "    margin-top: 10px;\n" +
                "    line-height: 46px;\n" +
                "    color: #FFF;\n" +
                "    font-weight: bold;\n" +
                "    border-radius: 22px;",
            click: function() {
               export_single('tiktok');
            } // 点击按钮时执行的函数
        });
        // 将按钮添加到指定的<div>中
        $('.pdp-info-left').append(newTiktokButton);
        //
        var btn_product_lunbo_imgs = $("<button>", {
            text: '下载轮播图', // 按钮文本
            style: "display: block;\n" +
                "    z-index: 999;\n" +
                "    background: #fb7701;\n" +
                "    width: 180px;\n" +
                "    height: 46px;\n" +
                "    margin-top: 10px;\n" +
                "    line-height: 46px;\n" +
                "    color: #FFF;\n" +
                "    font-weight: bold;\n" +
                "    border-radius: 22px;",
            click: function() {
               get_product_lunbo_imgs();
            } // 点击按钮时执行的函数
        });
        $('.pdp-info-left').append(btn_product_lunbo_imgs);
        //
        var btn_product_details_imgs = $("<button>", {
            text: '下载Details图片', // 按钮文本
            style: "display: block;\n" +
                "    z-index: 999;\n" +
                "    background: #fb7701;\n" +
                "    width: 180px;\n" +
                "    height: 46px;\n" +
                "    margin-top: 10px;\n" +
                "    line-height: 46px;\n" +
                "    color: #FFF;\n" +
                "    font-weight: bold;\n" +
                "    border-radius: 22px;",
            click: function() {
               get_product_details_imgs();
            } // 点击按钮时执行的函数
        });
        $('.pdp-info-left').append(btn_product_details_imgs);
        //
        var btn_product_review_export = $("<button>", {
            text: '导出评论', // 按钮文本
            style: "display: block;\n" +
                "    z-index: 999;\n" +
                "    background: #fb7701;\n" +
                "    width: 180px;\n" +
                "    height: 46px;\n" +
                "    margin-top: 10px;\n" +
                "    line-height: 46px;\n" +
                "    color: #FFF;\n" +
                "    font-weight: bold;\n" +
                "    border-radius: 22px;",
            click: function() {
                //
                let current_url = window.location.href;
                if(current_url.indexOf('?')!=-1){
                   current_url+='&gyexportreview=1';
                }else{
                   current_url+='?gyexportreview=1';
                }
                window.location.href = current_url;
                //
            } // 点击按钮时执行的函数
        });
        //$('.pdp-info-left').append(btn_product_review_export);
        //
    }
}

function formatNumberForCSV(num) {
  // 使用 toFixed(15) 将数字转换为字符串，15 是足够大的小数位数，可以满足大多数情况
  let str = num.toFixed(15);

  // 移除尾部多余的零
  str = str.replace(/\.?0+$/, '');

  // 如果字符串中包含小数点，则不使用科学计数法
  if (str.indexOf('.') !== -1) {
    return str;
  }

  // 否则，返回字符串形式的整数
  return parseInt(str, 10).toString();
}

function exportToCsv(data, fileName, sheetName) {
  // Create a new workbook
  var wb = XLSX.utils.book_new();

  // Convert your data to an array of arrays (2D array)
  var wsData = XLSX.utils.json_to_sheet(data);

  // Add the worksheet to the workbook
  XLSX.utils.book_append_sheet(wb, wsData, sheetName);

  // Generate the Excel file and trigger a download
  XLSX.writeFile(wb, fileName + ".csv");
}

function exportToExcel(data, fileName, sheetName) {
  // Create a new workbook
  var wb = XLSX.utils.book_new();

  // Convert your data to an array of arrays (2D array)
  var wsData = XLSX.utils.json_to_sheet(data);

  // Add the worksheet to the workbook
  XLSX.utils.book_append_sheet(wb, wsData, sheetName);

  // Generate the Excel file and trigger a download
  XLSX.writeFile(wb, fileName + ".xlsx");
}

function export_shopify_csv_output(need_item){
    let export_datas = [];
    //
    if (true) {
        let shangjia_about_contact_and_basic_info = need_item;
        let _shangjia_goodsId = shangjia_about_contact_and_basic_info['_shangjia_goodsId']
        //
        let _shangjia_variants_skus = shangjia_about_contact_and_basic_info['_shangjia_variants_skus'];
        //
        let _shangjia_gallery_arr = shangjia_about_contact_and_basic_info['_shangjia_gallery'];

        let futu1 = '';
        let futu2 = '';
        let futu3 = '';
        let futu4 = '';
        let futu5 = '';

        let futu6 = '';
        let futu7 = '';
        let futu8 = '';
        let futu9 = '';
        let futu10 = '';

        let futu11 = '';
        let futu12 = '';
        let futu13 = '';
        let futu14 = '';
        let futu15 = '';

        let futu16 = '';
        let futu17 = '';
        let futu18 = '';
        let futu19 = '';
        let futu20 = '';

        if(_shangjia_gallery_arr.length>=1){
            futu1 = _shangjia_gallery_arr[0];
        }
        if(_shangjia_gallery_arr.length>=2){
            futu2 = _shangjia_gallery_arr[1];
        }
        if(_shangjia_gallery_arr.length>=3){
            futu3 = _shangjia_gallery_arr[2];
        }
        if(_shangjia_gallery_arr.length>=4){
            futu4 = _shangjia_gallery_arr[3];
        }
        if(_shangjia_gallery_arr.length>=5){
            futu5 = _shangjia_gallery_arr[4];
        }
        if(_shangjia_gallery_arr.length>=6){
            futu6 = _shangjia_gallery_arr[5];
        }
        if(_shangjia_gallery_arr.length>=7){
            futu7 = _shangjia_gallery_arr[6];
        }
        if(_shangjia_gallery_arr.length>=8){
            futu8 = _shangjia_gallery_arr[7];
        }
        if(_shangjia_gallery_arr.length>=9){
            futu9 = _shangjia_gallery_arr[8];
        }
        if(_shangjia_gallery_arr.length>=10){
            futu10 = _shangjia_gallery_arr[9];
        }
        if(_shangjia_gallery_arr.length>=11){
            futu11 = _shangjia_gallery_arr[10];
        }
        if(_shangjia_gallery_arr.length>=12){
            futu12 = _shangjia_gallery_arr[11];
        }
        if(_shangjia_gallery_arr.length>=13){
            futu13 = _shangjia_gallery_arr[12];
        }
        if(_shangjia_gallery_arr.length>=14){
            futu14 = _shangjia_gallery_arr[13];
        }
        if(_shangjia_gallery_arr.length>=15){
            futu15 = _shangjia_gallery_arr[14];
        }
        if(_shangjia_gallery_arr.length>=16){
            futu16 = _shangjia_gallery_arr[15];
        }
        if(_shangjia_gallery_arr.length>=17){
            futu17 = _shangjia_gallery_arr[16];
        }
        if(_shangjia_gallery_arr.length>=18){
            futu18 = _shangjia_gallery_arr[17];
        }
        if(_shangjia_gallery_arr.length>=19){
            futu19 = _shangjia_gallery_arr[18];
        }
        if(_shangjia_gallery_arr.length>=20){
            futu20 = _shangjia_gallery_arr[19];
        }
        //
        let _shangjia_sold = shangjia_about_contact_and_basic_info['_shangjia_sold'];
        if(_shangjia_sold){
            _shangjia_sold = _shangjia_sold.replace('sold, by','').replace('By','');
            _shangjia_sold = _shangjia_sold.trim();
        }
        //
        let _shangjia_store_items = shangjia_about_contact_and_basic_info['_shangjia_store_items'];
        if(_shangjia_store_items){
            _shangjia_store_items = _shangjia_store_items.replace('Items','');
            _shangjia_store_items = _shangjia_store_items.trim();
        }
        //
        let _body_html = shangjia_about_contact_and_basic_info['_shangjia_goodsProperty'];
        let _shangjia_productDetailFlatList = shangjia_about_contact_and_basic_info['_shangjia_productDetailFlatList'];
        let _shangjia_productDetailFlatList_html = '';
        for(_f=0;_f<_shangjia_productDetailFlatList.length;_f++){
            _shangjia_productDetailFlatList_html += "<img src='"+_shangjia_productDetailFlatList[_f]+"' />";
        }
        _body_html += "<br />"+_shangjia_productDetailFlatList_html;
        //
        let good_url = window.location.href;
        good_url = good_url.trim();
        if(good_url.indexOf('?')!=-1){
            let good_url_arr = good_url.split('?');
            good_url = good_url_arr[0];
        }
        let handle = good_url.replace('https://www.aliexpress.us/','').replace('.html','').replaceAll('/','-');

        for(let i=0;i<_shangjia_variants_skus.length;i++){
            //
            let imgsrc = '';
            if(i==0){
                imgsrc = futu1;
            }else if(i==1){
                imgsrc = futu2;
            }else if(i==2){
                imgsrc = futu3;
            }else if(i==3){
                imgsrc = futu4;
            }else if(i==4){
                imgsrc = futu5;
            }else if(i==5){
                imgsrc = futu6;
            }else if(i==6){
                imgsrc = futu7;
            }else if(i==7){
                imgsrc = futu8;
            }else if(i==8){
                imgsrc = futu9;
            }else if(i==9){
                imgsrc = futu10;
            }else if(i==10){
                imgsrc = futu11;
            }else if(i==11){
                imgsrc = futu12;
            }else if(i==12){
                imgsrc = futu13;
            }else if(i==13){
                imgsrc = futu14;
            }else if(i==14){
                imgsrc = futu15;
            }else if(i==15){
                imgsrc = futu16;
            }else if(i==16){
                imgsrc = futu17;
            }else if(i==17){
                imgsrc = futu18;
            }else if(i==18){
                imgsrc = futu19;
            }else if(i==19){
                imgsrc = futu20;
            }
            //
            let specs_key1_name = _shangjia_variants_skus[i]['specs_key1_name'];
            let specs_key2_name = _shangjia_variants_skus[i]['specs_key2_name'];
            let specs_key3_name = _shangjia_variants_skus[i]['specs_key3_name'];
            let specs_key4_name = _shangjia_variants_skus[i]['specs_key4_name'];
            //
            let _skuId = _shangjia_variants_skus[i]['skuId'];
            _skuId = 'S'+_skuId;
            //
            let normalLinePriceStr = _shangjia_variants_skus[i]['normalLinePriceStr'];
            if(normalLinePriceStr){
                normalLinePriceStr = normalLinePriceStr.replace('$','');
            }
            let normalPriceStr = _shangjia_variants_skus[i]['normalPriceStr'];
            if(normalPriceStr){
                normalPriceStr = normalPriceStr.replace('$','');
            }
            //
            let export_data_item = {
                'Handle': handle,
                'Title': i==0?shangjia_about_contact_and_basic_info['_shangjia_goodsName']:'',
                'Body (HTML)': i==0?_body_html:'',
                'Vendor': i==0?'mysite':'',
                'Type':'',
                'Tags':'',
                'Published':i==0?'TRUE':'',
                'Option1 Name': specs_key1_name,
                'Option1 Value': _shangjia_variants_skus[i]['specs_key1_value'],
                'Option2 Name': specs_key2_name,
                'Option2 Value': _shangjia_variants_skus[i]['specs_key2_value'],
                'Option3 Name': specs_key3_name,
                'Option3 Value': _shangjia_variants_skus[i]['specs_key3_value'],
                'Variant SKU': _skuId,
                'Variant Grams': 0,
                'Variant Inventory Tracker':'shopify',
                'Variant Inventory Qty': _shangjia_variants_skus[i]['stockQuantity'],
                'Variant Inventory Policy':'continue',
                'Variant Fulfillment Service':'manual',
                'Variant Price':normalPriceStr,
                'Variant Compare At Price':normalLinePriceStr,
                'Variant Requires Shipping':'TRUE',
                'Variant Taxable':'TRUE',
                'Variant Barcode':'',
                'Image Src': imgsrc,
                'Image Position': imgsrc?(i+1):'',
                'Image Alt Text':'',
                'Gift Card': i==0?'FALSE':'',
                'SEO Title': i==0?shangjia_about_contact_and_basic_info['_shangjia_goodsName']:'',
                'SEO Description': i==0?shangjia_about_contact_and_basic_info['_shangjia_goodsName']:'',
                'Google Shopping / Google Product Category':'',
                'Google Shopping / Gender':'',
                'Google Shopping / Age Group':'',
                'Google Shopping / MPN':'',
                'Google Shopping / AdWords Grouping':'',
                'Google Shopping / AdWords Labels':'',
                'Google Shopping / Condition':'',
                'Google Shopping / Custom Product':'',
                'Google Shopping / Custom Label 0':'',
                'Google Shopping / Custom Label 1':'',
                'Google Shopping / Custom Label 2':'',
                'Google Shopping / Custom Label 3':'',
                'Google Shopping / Custom Label 4':'',
                'Variant Image': _shangjia_variants_skus[i]['img'],
                'Variant Weight Unit':'',
                'Variant Tax Code':'',
                'Cost per item':'',
                'Status':i==0?'active':''
            }
            export_datas.push(export_data_item);
            //
        }
        //
        if(_shangjia_gallery_arr.length > _shangjia_variants_skus.length){
            //
            for(let _g=_shangjia_variants_skus.length;_g<_shangjia_gallery_arr.length;_g++){
                let export_data_item = {
                    'Handle': handle,
                    'Title': '',
                    'Body (HTML)': '',
                    'Vendor': '',
                    'Type':'',
                    'Tags':'',
                    'Published':'',
                    'Option1 Name': '',
                    'Option1 Value': '',
                    'Option2 Name': '',
                    'Option2 Value': '',
                    'Option3 Name': '',
                    'Option3 Value': '',
                    'Variant SKU': '',
                    'Variant Grams': '',
                    'Variant Inventory Tracker':'',
                    'Variant Inventory Qty': '',
                    'Variant Inventory Policy':'',
                    'Variant Fulfillment Service':'',
                    'Variant Price':'',
                    'Variant Compare At Price':'',
                    'Variant Requires Shipping':'',
                    'Variant Taxable':'',
                    'Variant Barcode':'',
                    'Image Src': _shangjia_gallery_arr[_g],
                    'Image Position': (_g+1),
                    'Image Alt Text':'',
                    'Gift Card': '',
                    'SEO Title': '',
                    'SEO Description': '',
                    'Google Shopping / Google Product Category':'',
                    'Google Shopping / Gender':'',
                    'Google Shopping / Age Group':'',
                    'Google Shopping / MPN':'',
                    'Google Shopping / AdWords Grouping':'',
                    'Google Shopping / AdWords Labels':'',
                    'Google Shopping / Condition':'',
                    'Google Shopping / Custom Product':'',
                    'Google Shopping / Custom Label 0':'',
                    'Google Shopping / Custom Label 1':'',
                    'Google Shopping / Custom Label 2':'',
                    'Google Shopping / Custom Label 3':'',
                    'Google Shopping / Custom Label 4':'',
                    'Variant Image': '',
                    'Variant Weight Unit':'',
                    'Variant Tax Code':'',
                    'Cost per item':'',
                    'Status':''
                }
                export_datas.push(export_data_item);
            }
        }
        exportToCsv(export_datas, 'gycharm-aliexpress-shopify-export-'+_shangjia_goodsId, "Sheet1");
    }
}

function export_tiktok_xlsx_output(need_item){
    let export_datas = [];
    let shangjia_about_contact_and_basic_info = need_item;
    let _shangjia_goodsId = shangjia_about_contact_and_basic_info['_shangjia_goodsId']
    //
    let _shangjia_variants_skus = shangjia_about_contact_and_basic_info['_shangjia_variants_skus'];
    //
    let _shangjia_gallery_arr = shangjia_about_contact_and_basic_info['_shangjia_gallery'];

    let futu1 = '';
    let futu2 = '';
    let futu3 = '';
    let futu4 = '';
    let futu5 = '';

    let futu6 = '';
    let futu7 = '';
    let futu8 = '';
    let futu9 = '';
    let futu10 = '';

    let futu11 = '';
    let futu12 = '';
    let futu13 = '';
    let futu14 = '';
    let futu15 = '';

    let futu16 = '';
    let futu17 = '';
    let futu18 = '';
    let futu19 = '';
    let futu20 = '';

    if(_shangjia_gallery_arr.length>=1){
        futu1 = _shangjia_gallery_arr[0];
    }
    if(_shangjia_gallery_arr.length>=2){
        futu2 = _shangjia_gallery_arr[1];
    }
    if(_shangjia_gallery_arr.length>=3){
        futu3 = _shangjia_gallery_arr[2];
    }
    if(_shangjia_gallery_arr.length>=4){
        futu4 = _shangjia_gallery_arr[3];
    }
    if(_shangjia_gallery_arr.length>=5){
        futu5 = _shangjia_gallery_arr[4];
    }
    if(_shangjia_gallery_arr.length>=6){
        futu6 = _shangjia_gallery_arr[5];
    }
    if(_shangjia_gallery_arr.length>=7){
        futu7 = _shangjia_gallery_arr[6];
    }
    if(_shangjia_gallery_arr.length>=8){
        futu8 = _shangjia_gallery_arr[7];
    }
    if(_shangjia_gallery_arr.length>=9){
        futu9 = _shangjia_gallery_arr[8];
    }
    if(_shangjia_gallery_arr.length>=10){
        futu10 = _shangjia_gallery_arr[9];
    }
    if(_shangjia_gallery_arr.length>=11){
        futu11 = _shangjia_gallery_arr[10];
    }
    if(_shangjia_gallery_arr.length>=12){
        futu12 = _shangjia_gallery_arr[11];
    }
    if(_shangjia_gallery_arr.length>=13){
        futu13 = _shangjia_gallery_arr[12];
    }
    if(_shangjia_gallery_arr.length>=14){
        futu14 = _shangjia_gallery_arr[13];
    }
    if(_shangjia_gallery_arr.length>=15){
        futu15 = _shangjia_gallery_arr[14];
    }
    if(_shangjia_gallery_arr.length>=16){
        futu16 = _shangjia_gallery_arr[15];
    }
    if(_shangjia_gallery_arr.length>=17){
        futu17 = _shangjia_gallery_arr[16];
    }
    if(_shangjia_gallery_arr.length>=18){
        futu18 = _shangjia_gallery_arr[17];
    }
    if(_shangjia_gallery_arr.length>=19){
        futu19 = _shangjia_gallery_arr[18];
    }
    if(_shangjia_gallery_arr.length>=20){
        futu20 = _shangjia_gallery_arr[19];
    }
    //
    let _shangjia_sold = shangjia_about_contact_and_basic_info['_shangjia_sold'];
    if(_shangjia_sold){
        _shangjia_sold = _shangjia_sold.replace('sold, by','').replace('By','');
        _shangjia_sold = _shangjia_sold.trim();
    }
    //
    let _shangjia_store_items = shangjia_about_contact_and_basic_info['_shangjia_store_items'];
    if(_shangjia_store_items){
        _shangjia_store_items = _shangjia_store_items.replace('Items','');
        _shangjia_store_items = _shangjia_store_items.trim();
    }
    //
    for(let i=0;i<_shangjia_variants_skus.length;i++){
        //
        let specs_key1_name = _shangjia_variants_skus[i]['specs_key1_name'];
        let specs_key2_name = _shangjia_variants_skus[i]['specs_key2_name'];
        let specs_key3_name = _shangjia_variants_skus[i]['specs_key3_name'];
        let specs_key4_name = _shangjia_variants_skus[i]['specs_key4_name'];
        //
        let _skuId = _shangjia_variants_skus[i]['skuId'];
        _skuId = 'T'+_skuId;
        //
        let _category = shangjia_about_contact_and_basic_info['_shangjia_category'];
        let _category_str = '';
        let _category_arr = _category.split('>');
        if(_category_arr.length>=2){
            _category_str = _category_arr[1];
        }else{
            _category_str = _category_arr[0];
        }
        _category_str = _category_str.trim();

        let export_data_item = {
            'Category': _category_str,
            'Brand':'',
            'Product Name': shangjia_about_contact_and_basic_info['_shangjia_goodsName'],
            'Product Description': shangjia_about_contact_and_basic_info['_shangjia_goodsProperty'],
            'Package Weight(lb)':'',
            'Package Length(inch)':'',
            'Package Width(inch)':'',
            'Package Height(inch)':'',
            'Delivery options':'Default',
            'Identifier Code Type':'',
            'Identifier Code':'',
            '属性1名': specs_key1_name,
            'Variation 1': _shangjia_variants_skus[i]['specs_key1_value'],
            '属性2名': specs_key2_name,
            'Variation 2': _shangjia_variants_skus[i]['specs_key2_value'],
            '属性3名': specs_key3_name,
            'Variation 3': _shangjia_variants_skus[i]['specs_key3_value'],
            '属性4名': specs_key4_name,
            'Variation 4': _shangjia_variants_skus[i]['specs_key4_value'],
            'Variant Image': _shangjia_variants_skus[i]['img'],
            'Retail Price (Local Currency)': _shangjia_variants_skus[i]['normalPriceStr'],
            'Quantity in RUIZ SPORT STORE': _shangjia_variants_skus[i]['stockQuantity'],
            'Seller SKU': _skuId,
            'Main Product Image': _shangjia_variants_skus[i]['img'],
            'Product Image 2': futu1,
            'Product Image 3': futu2,
            'Product Image 4': futu3,
            'Product Image 5': futu4,
            'Product Image 6': futu5,
            'Product Image 7': futu6,
            'Product Image 8': futu7,
            'Product Image 9': futu8,
            'Product Image 10': futu9,
            'Product Image 11': futu10,
            'Product Image 12': futu11,
            'Product Image 13': futu12,
            'Product Image 14': futu13,
            'Product Image 15': futu14,
            'Product Image 16': futu15,
            'Product Image 17': futu16,
            'Product Image 18': futu17,
            'Product Image 19': futu18,
            'Product Image 20': futu19,
            'Product Image 21': futu20,
            'Size Chart':'',
            'Product Status':'',
        }
        export_datas.push(export_data_item);
        //
    }
    //
    exportToExcel(export_datas, 'gycharm-aliexpress-tiktok-export-'+Date.now(), "Sheet1");
    //
    //
}

function export_normail_xlsx_output(need_item){
    console.log('export_normail_xlsx_output');
    let export_datas = [];
    let shangjia_about_contact_and_basic_info = need_item;
    //
    let _shangjia_variants_skus = shangjia_about_contact_and_basic_info['_shangjia_variants_skus'];
    //
    let _shangjia_gallery_arr = shangjia_about_contact_and_basic_info['_shangjia_gallery'];

    let futu1 = '';
    let futu2 = '';
    let futu3 = '';
    let futu4 = '';
    let futu5 = '';

    let futu6 = '';
    let futu7 = '';
    let futu8 = '';
    let futu9 = '';
    let futu10 = '';

    let futu11 = '';
    let futu12 = '';
    let futu13 = '';
    let futu14 = '';
    let futu15 = '';

    let futu16 = '';
    let futu17 = '';
    let futu18 = '';
    let futu19 = '';
    let futu20 = '';

    if(_shangjia_gallery_arr.length>=1){
        futu1 = _shangjia_gallery_arr[0];
    }
    if(_shangjia_gallery_arr.length>=2){
        futu2 = _shangjia_gallery_arr[1];
    }
    if(_shangjia_gallery_arr.length>=3){
        futu3 = _shangjia_gallery_arr[2];
    }
    if(_shangjia_gallery_arr.length>=4){
        futu4 = _shangjia_gallery_arr[3];
    }
    if(_shangjia_gallery_arr.length>=5){
        futu5 = _shangjia_gallery_arr[4];
    }
    if(_shangjia_gallery_arr.length>=6){
        futu6 = _shangjia_gallery_arr[5];
    }
    if(_shangjia_gallery_arr.length>=7){
        futu7 = _shangjia_gallery_arr[6];
    }
    if(_shangjia_gallery_arr.length>=8){
        futu8 = _shangjia_gallery_arr[7];
    }
    if(_shangjia_gallery_arr.length>=9){
        futu9 = _shangjia_gallery_arr[8];
    }
    if(_shangjia_gallery_arr.length>=10){
        futu10 = _shangjia_gallery_arr[9];
    }
    if(_shangjia_gallery_arr.length>=11){
        futu11 = _shangjia_gallery_arr[10];
    }
    if(_shangjia_gallery_arr.length>=12){
        futu12 = _shangjia_gallery_arr[11];
    }
    if(_shangjia_gallery_arr.length>=13){
        futu13 = _shangjia_gallery_arr[12];
    }
    if(_shangjia_gallery_arr.length>=14){
        futu14 = _shangjia_gallery_arr[13];
    }
    if(_shangjia_gallery_arr.length>=15){
        futu15 = _shangjia_gallery_arr[14];
    }
    if(_shangjia_gallery_arr.length>=16){
        futu16 = _shangjia_gallery_arr[15];
    }
    if(_shangjia_gallery_arr.length>=17){
        futu17 = _shangjia_gallery_arr[16];
    }
    if(_shangjia_gallery_arr.length>=18){
        futu18 = _shangjia_gallery_arr[17];
    }
    if(_shangjia_gallery_arr.length>=19){
        futu19 = _shangjia_gallery_arr[18];
    }
    if(_shangjia_gallery_arr.length>=20){
        futu20 = _shangjia_gallery_arr[19];
    }
    //
    let _shangjia_sold = shangjia_about_contact_and_basic_info['_shangjia_sold'];
    if(_shangjia_sold){
        _shangjia_sold = _shangjia_sold.replace('sold, by','').replace('By','');
        _shangjia_sold = _shangjia_sold.trim();
    }
    //
    let _shangjia_store_items = shangjia_about_contact_and_basic_info['_shangjia_store_items'];
    if(_shangjia_store_items){
        _shangjia_store_items = _shangjia_store_items.replace('Items','');
        _shangjia_store_items = _shangjia_store_items.trim();
    }
    //
    let good_url = window.location.href;
    good_url = good_url.trim();
    if(good_url.indexOf('?')!=-1){
        let good_url_arr = good_url.split('?');
        good_url = good_url_arr[0];
    }
    //
    //
    let _body_html = shangjia_about_contact_and_basic_info['_shangjia_goodsProperty'];
    let _shangjia_productDetailFlatList = shangjia_about_contact_and_basic_info['_shangjia_productDetailFlatList'];
    let _shangjia_productDetailFlatList_html = '<div class="_23UQG0mN">';
    for(_f=0;_f<_shangjia_productDetailFlatList.length;_f++){
        _shangjia_productDetailFlatList_html += "<div style='margin-bottom:5px'><img src='"+_shangjia_productDetailFlatList[_f]+"' /></div>";
    }
    _shangjia_productDetailFlatList_html +='</div>';
    _body_html += "<br />"+_shangjia_productDetailFlatList_html;
    //
    //
    for(let i=0;i<_shangjia_variants_skus.length;i++){
        //
        let specs_key1_name = _shangjia_variants_skus[i]['specs_key1_name'];
        let specs_key2_name = _shangjia_variants_skus[i]['specs_key2_name'];
        let specs_key3_name = _shangjia_variants_skus[i]['specs_key3_name'];
        let specs_key4_name = _shangjia_variants_skus[i]['specs_key4_name'];
        //
        let normalLinePriceStr = '';
        if(_shangjia_variants_skus[i].hasOwnProperty('normalLinePriceStr')){
            normalLinePriceStr = _shangjia_variants_skus[i]['normalLinePriceStr'];
        }
        let export_data_item = {
            '产品url': good_url,
            'SKU': 'S'+shangjia_about_contact_and_basic_info['_shangjia_goodsId'],
            '原变体SKU': 'S'+_shangjia_variants_skus[i]['skuId'],
            '变体带属性SKU': 'S'+_shangjia_variants_skus[i]['subsku'],
            '产品标题': shangjia_about_contact_and_basic_info['_shangjia_goodsName'],
            'Category': shangjia_about_contact_and_basic_info['_shangjia_category'],
            '变体图片': _shangjia_variants_skus[i]['img'],
            '价格': _shangjia_variants_skus[i]['normalPriceStr'],
            '原价': normalLinePriceStr,
            '变体库存': _shangjia_variants_skus[i]['stockQuantity'],
            '运费':shangjia_about_contact_and_basic_info['_shangjia_shippingFee'],
            '评分':shangjia_about_contact_and_basic_info['_shangjia_review_rating'],
            '评论数':shangjia_about_contact_and_basic_info['_shangjia_review_totalValidNum'],
            //'运费描述':shangjia_about_contact_and_basic_info['_shangjia_shippingFee_label'],
           // '目的地':shangjia_about_contact_and_basic_info['_shangjia_shipping_Productdelivery'],
            '属性1名': specs_key1_name,
            '属性1值': _shangjia_variants_skus[i]['specs_key1_value'],
            '属性2名': specs_key2_name,
            '属性2值': _shangjia_variants_skus[i]['specs_key2_value'],
            '属性3名': specs_key3_name,
            '属性3值': _shangjia_variants_skus[i]['specs_key3_value'],
            '属性4名': specs_key4_name,
            '属性4值': _shangjia_variants_skus[i]['specs_key4_value'],
            '主图': shangjia_about_contact_and_basic_info['_shangjia_hdThumbUrl'],
            '附图1': futu1,
            '附图2': futu2,
            '附图3': futu3,
            '附图4': futu4,
            '附图5': futu5,
            '附图6': futu6,
            '附图7': futu7,
            '附图8': futu8,
            '附图9': futu9,
            '附图10': futu10,
            '附图11': futu11,
            '附图12': futu12,
            '附图13': futu13,
            '附图14': futu14,
            '附图15': futu15,
            '附图16': futu16,
            '附图17': futu17,
            '附图18': futu18,
            '附图19': futu19,
            '附图20': futu20,
            'VideoUrl': shangjia_about_contact_and_basic_info['_shangjia_VideoUrl'],
            '产品描述': _body_html,
            'Specifications':shangjia_about_contact_and_basic_info['_shangjia_specifications'],
            '描述图片': shangjia_about_contact_and_basic_info['_shangjia_productDetailFlatList'].join(','),
            //review
            //'review': shangjia_about_contact_and_basic_info['_shangjia_reivew_num'],
            //'sold': _shangjia_sold,
            //store
            'store name': shangjia_about_contact_and_basic_info['_shangjia_store_name'],
            'store url': shangjia_about_contact_and_basic_info['_shangjia_store_url'],
            //'store sold': shangjia_about_contact_and_basic_info['_shangjia_store_sold'],
            //'store review': shangjia_about_contact_and_basic_info['_shangjia_store_review_num'],
            //'store score': shangjia_about_contact_and_basic_info['_shangjia_store_score'],
            //'store followers': shangjia_about_contact_and_basic_info['_shangjia_store_followers'],
             //'store items': _shangjia_store_items
             //
             //'is request': shangjia_about_contact_and_basic_info['_is_request'] == 2 ? '已完成':'未',
        }
        export_datas.push(export_data_item);
       //
    }
     //
    exportToExcel(export_datas, 'gycharm-aliexpress-normail-export-'+Date.now(), "Sheet1");
    //
}

function export_single_(){
    let query_params = util_getCurrentUrlQueryStringParams();
    if(query_params.hasOwnProperty('gypingtai')){
        console.log('export_single_');
        $('#gycharm-custom-msg').remove();
        let pingtai = query_params['gypingtai'];
        let current_url = window.location.href;
        let current_url_arr = current_url.split('?');
        let _shangjia_about_contact_and_basic_info_link = current_url_arr[0];
        //
        let performanceData  = null;
        try{
            performanceData = window.performance;
        }catch  (error) {
            console.error("iframePerformance:", error);
        }
        if (performanceData!==null) {
            // 变量已定义
            // 获取网络请求条目
            let resources = performanceData.getEntriesByType('resource');
            // 筛选出类型为 script 且 src 包含特定字符串的条目
            const targetScripts = resources.filter(resource =>
                resource.initiatorType === "script" &&
                resource.name.includes("mtop.aliexpress.itemdetail.pc.asyncpcdetail")
            );
            // 获取并输出每个符合条件的 script 资源的内容
            targetScripts.forEach(script => {
                fetch(script.name,{ credentials: 'include' })
                    .then(response => response.text())
                    .then(content => {
                        console.log(`Content of script ${script.name}:`);
                        //console.log(content);
                        //
                        let runParamscript = content.replace('mtopjsonp1(','');
                        runParamscript = runParamscript.slice(0,-1);
                        console.log('runParamscript');
                        console.log(runParamscript);
                        //
                        let runParamscript_data_json = JSON.parse(runParamscript);
                        console.log(runParamscript_data_json);
                        let runParamscript_json = runParamscript_data_json['data']['data'];
                        if(runParamscript_json){
                            //
                            let _skus = runParamscript_json['priceComponent']['skuPriceList'];
                            let _item = runParamscript_json['productInfoComponent'];
                            let need_item = {
                                    '_shangjia_about_contact_and_basic_info_link_key':query_params['_shangjia_about_contact_and_basic_info_link_key'],
                                    '_shangjia_id': '',
                                    '_shangjia_about_contact_and_basic_info_link': _shangjia_about_contact_and_basic_info_link,

                                    '_shangjia_store_name': '',
                                    '_shangjia_store_url': '',
                                    '_shangjia_store_items': '',
                                    '_shangjia_store_followers': '',
                                    '_shangjia_store_sold': '',
                                    '_shangjia_store_score': '',
                                    //
                                    '_shangjia_goodsId': '', //sku
                                    '_shangjia_variants_skus': [], //数组
                                    '_shangjia_goodsName': '',
                                    '_shangjia_goodsProperty': '',//description,deschtml
                                    '_shangjia_minOnSalePriceStr': '', //最小价格,当没有属性时选择该价格
                                    '_shangjia_hdThumbUrl': '',//主图
                                    '_shangjia_gallery': [], //图片列表
                                    '_shangjia_productDetailFlatList': [],//details imgs
                                    '_shangjia_category': '',//brumb
                                    '_shangjia_VideoUrl': '', //video
                                    '_shangjia_specifications':'',
                                    '_shangjia_shippingFee':'',
                                    '_shangjia_shippingFee_label':'',
                                    '_shangjia_shipping_Productdelivery':'',
                                    '_shangjia_review_rating':'',
                                    '_shangjia_review_totalValidNum':''
                                    //
                            };
                            let _shangjia_variants_skus = [];
                            if(_skus && _skus.length > 0){
                                if(runParamscript_json['skuComponent']['hasSkuProperty']){
                                    //
                                    let _productSKUPropertyList = runParamscript_json['skuComponent']['productSKUPropertyList'];
                                    //
                                    for(let _i=0;_i<_skus.length;_i++){
                                        //
                                        let specs_key1_name = '';
                                        let specs_key1_value = '';
                                        let specs_key2_name = '';
                                        let specs_key2_value = '';
                                        let specs_key3_name = '';
                                        let specs_key3_value = '';
                                        let specs_key4_name = '';
                                        let specs_key4_value = '';
                                        let _attr_img = '';
                                        //
                                        let skuAttr = _skus[_i]['skuAttr'];
                                        let skuAttrArr = skuAttr.split(';');

                                        //
                                        let skuAttrArrLength = skuAttrArr.length;

                                        if(_productSKUPropertyList[_productSKUPropertyList.length-1]['skuPropertyName'] =="Ships From"){
                                            skuAttrArrLength = skuAttrArrLength-1;
                                        }
                                        //

                                        if(skuAttrArrLength == 1){
                                            let _attr_value = skuAttrArr[0];
                                            let _attr_value_arr = _attr_value.split(':');
                                            let _attr_name_id = _attr_value_arr[0];
                                            let _attr_value_id = _attr_value_arr[1];
                                            let attr_name_value_arr = util_get_attr_name_value(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key1_name = attr_name_value_arr['_attr_name'];
                                            specs_key1_value = attr_name_value_arr['_attr_value_name'];
                                            if(_attr_img == '' && attr_name_value_arr['_attr_img']){
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                        }else if(skuAttrArrLength == 2){
                                            let _attr_value = skuAttrArr[0];
                                            let _attr_value_arr = _attr_value.split(':');
                                            let _attr_name_id = _attr_value_arr[0];
                                            let _attr_value_id = _attr_value_arr[1];
                                            let attr_name_value_arr = util_get_attr_name_value(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key1_name = attr_name_value_arr['_attr_name'];
                                            specs_key1_value = attr_name_value_arr['_attr_value_name'];
                                            if(_attr_img == '' && attr_name_value_arr['_attr_img']){
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                            _attr_value = skuAttrArr[1];
                                            _attr_value_arr = _attr_value.split(':');
                                            _attr_name_id = _attr_value_arr[0];
                                            _attr_value_id = _attr_value_arr[1];
                                            attr_name_value_arr = util_get_attr_name_value(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key2_name = attr_name_value_arr['_attr_name'];
                                            specs_key2_value = attr_name_value_arr['_attr_value_name'];
                                            if(_attr_img == '' && attr_name_value_arr['_attr_img']){
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                        }else if(skuAttrArrLength == 3){
                                            let _attr_value = skuAttrArr[0];
                                            let _attr_value_arr = _attr_value.split(':');
                                            let _attr_name_id = _attr_value_arr[0];
                                            let _attr_value_id = _attr_value_arr[1];
                                            let attr_name_value_arr = util_get_attr_name_value(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key1_name = attr_name_value_arr['_attr_name'];
                                            specs_key1_value = attr_name_value_arr['_attr_value_name'];
                                            if(_attr_img == '' && attr_name_value_arr['_attr_img']){
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                            _attr_value = skuAttrArr[1];
                                            _attr_value_arr = _attr_value.split(':');
                                            _attr_name_id = _attr_value_arr[0];
                                            _attr_value_id = _attr_value_arr[1];
                                            attr_name_value_arr = util_get_attr_name_value(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key2_name = attr_name_value_arr['_attr_name'];
                                            specs_key2_value = attr_name_value_arr['_attr_value_name'];
                                            if(_attr_img == '' && attr_name_value_arr['_attr_img']){
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                            _attr_value = skuAttrArr[2];
                                            _attr_value_arr = _attr_value.split(':');
                                            _attr_name_id = _attr_value_arr[0];
                                            _attr_value_id = _attr_value_arr[1];
                                            attr_name_value_arr = util_get_attr_name_value(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key3_name = attr_name_value_arr['_attr_name'];
                                            specs_key3_value = attr_name_value_arr['_attr_value_name'];
                                            if(_attr_img == '' && attr_name_value_arr['_attr_img']){
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                        }else if(skuAttrArrLength == 4){
                                            let _attr_value = skuAttrArr[0];
                                            let _attr_value_arr = _attr_value.split(':');
                                            let _attr_name_id = _attr_value_arr[0];
                                            let _attr_value_id = _attr_value_arr[1];
                                            let attr_name_value_arr = util_get_attr_name_value(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key1_name = attr_name_value_arr['_attr_name'];
                                            specs_key1_value = attr_name_value_arr['_attr_value_name'];
                                            if(_attr_img == '' && attr_name_value_arr['_attr_img']){
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                            _attr_value = skuAttrArr[1];
                                            _attr_value_arr = _attr_value.split(':');
                                            _attr_name_id = _attr_value_arr[0];
                                            _attr_value_id = _attr_value_arr[1];
                                            attr_name_value_arr = util_get_attr_name_value(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key2_name = attr_name_value_arr['_attr_name'];
                                            specs_key2_value = attr_name_value_arr['_attr_value_name'];
                                            if(_attr_img == '' && attr_name_value_arr['_attr_img']){
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                            _attr_value = skuAttrArr[2];
                                            _attr_value_arr = _attr_value.split(':');
                                            _attr_name_id = _attr_value_arr[0];
                                            _attr_value_id = _attr_value_arr[1];
                                            attr_name_value_arr = util_get_attr_name_value(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key3_name = attr_name_value_arr['_attr_name'];
                                            specs_key3_value = attr_name_value_arr['_attr_value_name'];
                                            if(_attr_img == '' && attr_name_value_arr['_attr_img']){
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                            _attr_value = skuAttrArr[3];
                                            _attr_value_arr = _attr_value.split(':');
                                            _attr_name_id = _attr_value_arr[0];
                                            _attr_value_id = _attr_value_arr[1];
                                            attr_name_value_arr = util_get_attr_name_value(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key4_name = attr_name_value_arr['_attr_name'];
                                            specs_key4_value = attr_name_value_arr['_attr_value_name'];
                                            if(_attr_img == '' && attr_name_value_arr['_attr_img']){
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                        }
                                        //
                                        let _skuVal = _skus[_i]['skuVal'];
                                        let normalPriceStr = _skus[_i]['skuVal']['skuAmount']['formatedAmount'];
                                        if(_skuVal.hasOwnProperty('skuActivityAmount')){
                                            normalPriceStr = _skus[_i]['skuVal']['skuActivityAmount']['formatedAmount'];
                                        }
                                        //
                                        _shangjia_variants_skus.push({
                                            'subsku': _item['id']+specs_key1_value+specs_key2_value+specs_key3_value+specs_key4_value,
                                            'normalPriceStr': normalPriceStr,
                                            'normalLinePriceStr':_skus[_i]['skuVal']['skuAmount']['formatedAmount'],
                                            'img':_attr_img,
                                            'specs_key1_name':specs_key1_name,
                                            'specs_key1_value':specs_key1_value,
                                            'specs_key2_name':specs_key2_name,
                                            'specs_key2_value':specs_key2_value,
                                            'specs_key3_name':specs_key3_name,
                                            'specs_key3_value':specs_key3_value,
                                            'specs_key4_name':specs_key4_name,
                                            'specs_key4_value':specs_key4_value,
                                            'stockQuantity': _skus[_i]['skuVal']['inventory'],
                                            'skuId': _skus[_i]['skuId']
                                        });
                                        //
                                    }
                                    //
                                }else{
                                    //没有属性
                                    let _sku = _skus[0];
                                    let _skuVal = _sku['skuVal'];
                                    let normalPriceStr = _sku['skuVal']['skuAmount']['formatedAmount'];
                                    if(_skuVal.hasOwnProperty('skuActivityAmount')){
                                        normalPriceStr = _sku['skuVal']['skuActivityAmount']['formatedAmount'];
                                    }
                                    _shangjia_variants_skus.push({
                                        'subsku': _item['id'],
                                        'normalPriceStr': normalPriceStr,
                                        'normalLinePriceStr':_sku['skuVal']['skuAmount']['formatedAmount'],
                                        'img':'',
                                        'specs_key1_name':'',
                                        'specs_key1_value':'',
                                        'specs_key2_name':'',
                                        'specs_key2_value':'',
                                        'specs_key3_name':'',
                                        'specs_key3_value':'',
                                        'specs_key4_name':'',
                                        'specs_key4_value':'',
                                        'stockQuantity': _sku['skuVal']['inventory'],
                                        'skuId': _item['id']
                                    });
                                    //
                                }
                            }
                            need_item['_shangjia_variants_skus'] = _shangjia_variants_skus;
                            //
                            need_item['_shangjia_goodsId'] = _item['id'];
                            need_item['_shangjia_goodsName'] = _item['subject'];
                            need_item['_shangjia_minOnSalePriceStr'] = _item['minPrice'];
                            //
                            let _shangjia_VideoUrl = '';
                            let _shangjia_gallery = runParamscript_json['imageComponent']['imagePathList'];
                            need_item['_shangjia_gallery'] = _shangjia_gallery;
                            if(_shangjia_gallery.length > 0){
                                need_item['_shangjia_hdThumbUrl'] = _shangjia_gallery[0];
                            }
                            need_item['_shangjia_VideoUrl'] = _shangjia_VideoUrl;
                            //
                            need_item['_shangjia_category'] = '';
                            need_item['_shangjia_sold'] = runParamscript_json['tradeComponent']['formatTradeCount'];
                            need_item['_shangjia_reivew_num'] = runParamscript_json['feedbackComponent']['totalValidNum'];
                            //
                            let _shangjia_shippingFee = $(".pdp-body-top-right div[class*='shipping--item'] div[class*='shipping--content'] .dynamic-shipping .dynamic-shipping-titleLayout > span:eq(0)").text();
                            need_item['_shangjia_shippingFee'] = _shangjia_shippingFee;
                            //
                            let _shangjia_shippingFee_label = $(".pdp-body-top-right div[class*='shipping--item'] div[class*='shipping--content'] .dynamic-shipping .dynamic-shipping-contentLayout:eq(0)").text();
                            need_item['_shangjia_shippingFee_label'] = _shangjia_shippingFee_label;
                            //
                            let _shangjia_shipping_Productdelivery = $("div[data-pl='product-delivery']").text();
                            if(_shangjia_shipping_Productdelivery){
                                _shangjia_shipping_Productdelivery = _shangjia_shipping_Productdelivery.replace('Ship to','');
                            }
                            need_item['_shangjia_shipping_Productdelivery'] = _shangjia_shipping_Productdelivery;

                            //
                            if(runParamscript_json.hasOwnProperty('PC_RATING')){
                                need_item['_shangjia_review_rating'] = runParamscript_json['PC_RATING']['rating'];
                                need_item['_shangjia_review_totalValidNum'] = runParamscript_json['PC_RATING']['totalValidNum'];
                            }
                            //
                            //
                            let _shangjia_specifications = '';
                            if(runParamscript_json.hasOwnProperty('productPropComponent')){
                                let productPropComponent = runParamscript_json['productPropComponent'];
                                if(productPropComponent.hasOwnProperty('props')){
                                    let props = productPropComponent['props'];
                                    if(props.length > 0){
                                        for(let pi=0; pi<props.length; pi++){
                                            _shangjia_specifications+="<div class='specification--prop--RejitI8'><div class='specification--title--UbVeyic'><span>"+props[pi]['attrName']+"</span></div><div class='specification--desc--Mz148Bl'><span>"+props[pi]['attrValue']+"</span></div></div>";
                                        }
                                        _shangjia_specifications = "<div class='specification--list--fiWsSyv'>"+_shangjia_specifications+"</div>";
                                    }
                                }
                            }
                            need_item['_shangjia_specifications'] = _shangjia_specifications;
                            //
                            let sellerComponent = runParamscript_json['sellerComponent'];
                            let storeURL = sellerComponent['storeURL'];
                            storeURL = storeURL.replace('//','https://');
                            need_item['_shangjia_store_name'] = sellerComponent['storeName'];
                            need_item['_shangjia_store_url'] = storeURL;
                            need_item['_shangjia_store_items'] = '';
                            need_item['_shangjia_store_followers'] = '';
                            need_item['_shangjia_store_sold'] = '';
                            need_item['_shangjia_store_score'] = '';
                            need_item['_shangjia_store_country'] = sellerComponent['countryCompleteName'];
                            need_item['_shangjia_store_opentime'] = sellerComponent['formatOpenTime'];
                            //
                            let descriptionUrl =  runParamscript_json['productDescComponent']['descriptionUrl'];
                            //
                            let message = {
                                action: 'get_description',
                                url: descriptionUrl
                            };
                            chrome.runtime.sendMessage(message,(msg)=>{
                                console.log('get_description 答复',msg)
                                let msgobj  = JSON.parse(msg);
                                let description_data = msgobj['description'];
                                console.log('description_data');
                                console.log(description_data);
                                //
                                if(description_data){
                                    description_data = '<div>'+description_data+'</div>';
                                    description_data = description_data.replaceAll('(','');
                                    description_data = description_data.replaceAll(')','');
                                    let _description_data_dom = $(description_data);
                                    let _shangjia_productDetailFlatList = [];
                                    _description_data_dom.find('img').each(function () {
                                        _shangjia_productDetailFlatList.push($(this).attr('src'));
                                    })
                                    need_item['_shangjia_productDetailFlatList'] = _shangjia_productDetailFlatList;
                                    //
                                    need_item['_shangjia_goodsProperty'] = description_data.replace(/<a\s+href="[^"]*"/g, '<a href="#"');
                                    //
                                }
                                need_item['_is_request'] = 2;

                                //export csv
                                console.log('need_item');
                                console.log(need_item);
                                //
                                if(pingtai == 'shopify'){
                                    export_shopify_csv_output(need_item);
                                }else if(pingtai == 'tiktok'){
                                    export_tiktok_xlsx_output(need_item);
                                }else if(pingtai == 'normal'){
                                    export_normail_xlsx_output(need_item);
                                }
                                //
                            })
                        }else{
                            //alert('未获取到数据，请联系客服！');
                             setTimeout(function() {
                                        location.reload();
                                    }, 30000);
                        }
                        //
                    })
                    .catch(error => {
                        console.error(`Failed to fetch script ${script.name}:`, error);
                        setTimeout(function() {
                                        location.reload();
                                    }, 30000);
                    });
            });
        }
    }
}

function export_single_you(){
    let query_params = util_getCurrentUrlQueryStringParams();
    if(query_params.hasOwnProperty('gypingtai')){
        $('#gycharm-custom-msg').remove();
        let pingtai = query_params['gypingtai'];
        let current_url = window.location.href;
        let current_url_arr = current_url.split('?');
        let _shangjia_about_contact_and_basic_info_link = current_url_arr[0];
        //
        let performanceData  = null;
        try{
            performanceData = window.performance;
        }catch  (error) {
            console.error("iframePerformance:", error);
        }
        if (performanceData!==null) {
            // 变量已定义
            // 获取网络请求条目
            let resources = performanceData.getEntriesByType('resource');
            // 筛选出类型为 script 且 src 包含特定字符串的条目
            let targetScripts = resources.filter(resource =>
                resource.initiatorType === "script" &&
                resource.name.includes("mtop.aliexpress.pdp.pc.query")
            );
            // 获取并输出每个符合条件的 script 资源的内容
            targetScripts.forEach(script => {
                fetch(script.name,{ credentials: 'include' })
                    .then(response => response.text())
                    .then(content => {
                        console.log(`Content of script ${script.name}:`);
                        //console.log(content);
                        //
                        let runParamscript = content.replace('mtopjsonp1(','');
                        runParamscript = runParamscript.slice(0,-1);
                        console.log('runParamscript');
                        console.log(runParamscript);
                        //
                        let runParamscript_data_json = JSON.parse(runParamscript);
                        console.log(runParamscript_data_json);
                        let runParamscript_json = runParamscript_data_json['data']['result'];
                        if(runParamscript_json){
                            //
                            let _skus = runParamscript_json['SKU']['skuPaths'];
                            let _item = runParamscript_json['GLOBAL_DATA']['globalData'];
                            let need_item = {
                                    '_shangjia_about_contact_and_basic_info_link_key':query_params['_shangjia_about_contact_and_basic_info_link_key'],
                                    '_shangjia_id': '',
                                    '_shangjia_about_contact_and_basic_info_link': _shangjia_about_contact_and_basic_info_link,

                                    '_shangjia_store_name': '',
                                    '_shangjia_store_url': '',
                                    '_shangjia_store_items': '',
                                    '_shangjia_store_followers': '',
                                    '_shangjia_store_sold': '',
                                    '_shangjia_store_score': '',
                                    //
                                    '_shangjia_goodsId': '', //sku
                                    '_shangjia_variants_skus': [], //数组
                                    '_shangjia_goodsName': '',
                                    '_shangjia_goodsProperty': '',//description,deschtml
                                    '_shangjia_minOnSalePriceStr': '', //最小价格,当没有属性时选择该价格
                                    '_shangjia_hdThumbUrl': '',//主图
                                    '_shangjia_gallery': [], //图片列表
                                    '_shangjia_productDetailFlatList': [],//details imgs
                                    '_shangjia_category': '',//brumb
                                    '_shangjia_VideoUrl': '', //video
                                    '_shangjia_shippingFee':'',
                                    '_shangjia_shippingFee_label':'',
                                    '_shangjia_shipping_Productdelivery':'',
                                    '_shangjia_review_rating':'',
                                    '_shangjia_review_totalValidNum':''
                            };
                            let _shangjia_variants_skus = [];
                            if(_skus && _skus.length > 0){
                                let _productSKUPropertyList = runParamscript_json['SKU']['skuProperties'];
                                let skuIdStrPriceInfoMap = runParamscript_json['PRICE']['skuIdStrPriceInfoMap'];
                                if(_productSKUPropertyList.length > 0) {
                                    //
                                    for (let _i = 0; _i < _skus.length; _i++) {
                                        //
                                        if(_skus[_i]['salable'] == false){
                                            continue;
                                        }
                                        //
                                        let specs_key1_name = '';
                                        let specs_key1_value = '';
                                        let specs_key2_name = '';
                                        let specs_key2_value = '';
                                        let specs_key3_name = '';
                                        let specs_key3_value = '';
                                        let specs_key4_name = '';
                                        let specs_key4_value = '';
                                        let _attr_img = '';
                                        //
                                        let skuAttr = _skus[_i]['path'];
                                        let skuAttrArr = skuAttr.split(';');
                                        //
                                        let skuAttrArrLength = skuAttrArr.length;

                                        if (_productSKUPropertyList[_productSKUPropertyList.length - 1]['skuPropertyName'] == "Ships From") {
                                            skuAttrArrLength = skuAttrArrLength - 1;
                                        }
                                        //
                                        if (skuAttrArrLength == 1) {
                                            let _attr_value = skuAttrArr[0];
                                            let _attr_value_arr = _attr_value.split(':');
                                            let _attr_name_id = _attr_value_arr[0];
                                            let _attr_value_id = _attr_value_arr[1];
                                            let attr_name_value_arr = util_get_attr_name_value_format(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key1_name = attr_name_value_arr['_attr_name'];
                                            specs_key1_value = attr_name_value_arr['_attr_value_name'];
                                            if (_attr_img == '' && attr_name_value_arr['_attr_img']) {
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                        } else if (skuAttrArrLength == 2) {
                                            let _attr_value = skuAttrArr[0];
                                            let _attr_value_arr = _attr_value.split(':');
                                            let _attr_name_id = _attr_value_arr[0];
                                            let _attr_value_id = _attr_value_arr[1];
                                            let attr_name_value_arr = util_get_attr_name_value_format(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key1_name = attr_name_value_arr['_attr_name'];
                                            specs_key1_value = attr_name_value_arr['_attr_value_name'];
                                            if (_attr_img == '' && attr_name_value_arr['_attr_img']) {
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                            _attr_value = skuAttrArr[1];
                                            _attr_value_arr = _attr_value.split(':');
                                            _attr_name_id = _attr_value_arr[0];
                                            _attr_value_id = _attr_value_arr[1];
                                            attr_name_value_arr = util_get_attr_name_value_format(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key2_name = attr_name_value_arr['_attr_name'];
                                            specs_key2_value = attr_name_value_arr['_attr_value_name'];
                                            if (_attr_img == '' && attr_name_value_arr['_attr_img']) {
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                        } else if (skuAttrArrLength == 3) {
                                            let _attr_value = skuAttrArr[0];
                                            let _attr_value_arr = _attr_value.split(':');
                                            let _attr_name_id = _attr_value_arr[0];
                                            let _attr_value_id = _attr_value_arr[1];
                                            let attr_name_value_arr = util_get_attr_name_value_format(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key1_name = attr_name_value_arr['_attr_name'];
                                            specs_key1_value = attr_name_value_arr['_attr_value_name'];
                                            if (_attr_img == '' && attr_name_value_arr['_attr_img']) {
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                            _attr_value = skuAttrArr[1];
                                            _attr_value_arr = _attr_value.split(':');
                                            _attr_name_id = _attr_value_arr[0];
                                            _attr_value_id = _attr_value_arr[1];
                                            attr_name_value_arr = util_get_attr_name_value_format(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key2_name = attr_name_value_arr['_attr_name'];
                                            specs_key2_value = attr_name_value_arr['_attr_value_name'];
                                            if (_attr_img == '' && attr_name_value_arr['_attr_img']) {
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                            _attr_value = skuAttrArr[2];
                                            _attr_value_arr = _attr_value.split(':');
                                            _attr_name_id = _attr_value_arr[0];
                                            _attr_value_id = _attr_value_arr[1];
                                            attr_name_value_arr = util_get_attr_name_value_format(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key3_name = attr_name_value_arr['_attr_name'];
                                            specs_key3_value = attr_name_value_arr['_attr_value_name'];
                                            if (_attr_img == '' && attr_name_value_arr['_attr_img']) {
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                        } else if (skuAttrArrLength == 4) {
                                            let _attr_value = skuAttrArr[0];
                                            let _attr_value_arr = _attr_value.split(':');
                                            let _attr_name_id = _attr_value_arr[0];
                                            let _attr_value_id = _attr_value_arr[1];
                                            let attr_name_value_arr = util_get_attr_name_value_format(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key1_name = attr_name_value_arr['_attr_name'];
                                            specs_key1_value = attr_name_value_arr['_attr_value_name'];
                                            if (_attr_img == '' && attr_name_value_arr['_attr_img']) {
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                            _attr_value = skuAttrArr[1];
                                            _attr_value_arr = _attr_value.split(':');
                                            _attr_name_id = _attr_value_arr[0];
                                            _attr_value_id = _attr_value_arr[1];
                                            attr_name_value_arr = util_get_attr_name_value_format(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key2_name = attr_name_value_arr['_attr_name'];
                                            specs_key2_value = attr_name_value_arr['_attr_value_name'];
                                            if (_attr_img == '' && attr_name_value_arr['_attr_img']) {
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                            _attr_value = skuAttrArr[2];
                                            _attr_value_arr = _attr_value.split(':');
                                            _attr_name_id = _attr_value_arr[0];
                                            _attr_value_id = _attr_value_arr[1];
                                            attr_name_value_arr = util_get_attr_name_value_format(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key3_name = attr_name_value_arr['_attr_name'];
                                            specs_key3_value = attr_name_value_arr['_attr_value_name'];
                                            if (_attr_img == '' && attr_name_value_arr['_attr_img']) {
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                            _attr_value = skuAttrArr[3];
                                            _attr_value_arr = _attr_value.split(':');
                                            _attr_name_id = _attr_value_arr[0];
                                            _attr_value_id = _attr_value_arr[1];
                                            attr_name_value_arr = util_get_attr_name_value_format(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key4_name = attr_name_value_arr['_attr_name'];
                                            specs_key4_value = attr_name_value_arr['_attr_value_name'];
                                            if (_attr_img == '' && attr_name_value_arr['_attr_img']) {
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                        }
                                        //
                                        let _skuIdStr = _skus[_i]['skuIdStr'];
                                        let normalPriceStr = skuIdStrPriceInfoMap[_skuIdStr]['salePriceString'];
                                        //
                                        let normalLinePriceStr = '';
                                        if(skuIdStrPriceInfoMap[_skuIdStr].hasOwnProperty('originalPrice')){
                                            normalLinePriceStr = skuIdStrPriceInfoMap[_skuIdStr]['originalPrice']['formatedAmount'];
                                        }
                                        //
                                        _shangjia_variants_skus.push({
                                            'subsku': _item['productId'] + specs_key1_value + specs_key2_value + specs_key3_value + specs_key4_value,
                                            'normalPriceStr': normalPriceStr,
                                            'normalLinePriceStr': normalLinePriceStr,
                                            'img': _attr_img,
                                            'specs_key1_name': specs_key1_name,
                                            'specs_key1_value': specs_key1_value,
                                            'specs_key2_name': specs_key2_name,
                                            'specs_key2_value': specs_key2_value,
                                            'specs_key3_name': specs_key3_name,
                                            'specs_key3_value': specs_key3_value,
                                            'specs_key4_name': specs_key4_name,
                                            'specs_key4_value': specs_key4_value,
                                            'stockQuantity': _skus[_i]['skuStock'],
                                            'skuId': _skuIdStr
                                        });
                                        //
                                    }
                                }else{
                                    //没有属性
                                    let _skuIdStr = _skus[0]['skuIdStr'];
                                    let normalPriceStr = skuIdStrPriceInfoMap[_skuIdStr]['salePriceString'];
                                    //
                                    _shangjia_variants_skus.push({
                                        'subsku': _item['productId'],
                                        'normalPriceStr': normalPriceStr,
                                        'normalLinePriceStr': '',
                                        'img': '',
                                        'specs_key1_name': '',
                                        'specs_key1_value': '',
                                        'specs_key2_name': '',
                                        'specs_key2_value': '',
                                        'specs_key3_name': '',
                                        'specs_key3_value': '',
                                        'specs_key4_name': '',
                                        'specs_key4_value': '',
                                        'stockQuantity': _skus[0]['skuStock'],
                                        'skuId': _item['productId']
                                    });
                                    //
                                }
                            }
                            //
                            need_item['_shangjia_variants_skus'] = _shangjia_variants_skus;
                            //
                            need_item['_shangjia_goodsId'] = _item['productId'];
                            need_item['_shangjia_goodsName'] = _item['subject'];
                            need_item['_shangjia_minOnSalePriceStr'] = $('.product-price-current').text();
                            //
                            let _shangjia_VideoUrl = '';
                            let _shangjia_gallery = runParamscript_json['HEADER_IMAGE_PC']['imagePathList'];
                            need_item['_shangjia_gallery'] = _shangjia_gallery;
                            if(_shangjia_gallery.length > 0){
                                need_item['_shangjia_hdThumbUrl'] = _shangjia_gallery[0];
                            }
                            need_item['_shangjia_VideoUrl'] = _shangjia_VideoUrl;
                            //
                            need_item['_shangjia_category'] = '';
                            need_item['_shangjia_sold'] = '';
                            need_item['_shangjia_reivew_num'] = '';
                            need_item['_shangjia_shippingFee'] = '';
                            need_item['_shangjia_shippingFee_label'] = '';
                            //
                            let _shangjia_shippingFee = $(".pdp-body-top-right div[class*='shipping--item'] div[class*='shipping--content'] .dynamic-shipping .dynamic-shipping-titleLayout > span:eq(0)").text();
                            need_item['_shangjia_shippingFee'] = _shangjia_shippingFee;
                            //
                            let _shangjia_shippingFee_label = $(".pdp-body-top-right div[class*='shipping--item'] div[class*='shipping--content'] .dynamic-shipping .dynamic-shipping-contentLayout:eq(0)").text();
                            need_item['_shangjia_shippingFee_label'] = _shangjia_shippingFee_label;
                            //
                            let _shangjia_shipping_Productdelivery = $("div[data-pl='product-delivery']").text();
                            if(_shangjia_shipping_Productdelivery){
                                _shangjia_shipping_Productdelivery = _shangjia_shipping_Productdelivery.replace('Ship to','');
                            }
                            need_item['_shangjia_shipping_Productdelivery'] = _shangjia_shipping_Productdelivery;
                            //
                            if(runParamscript_json.hasOwnProperty('PC_RATING')){
                                need_item['_shangjia_review_rating'] = runParamscript_json['PC_RATING']['rating'];
                                need_item['_shangjia_review_totalValidNum'] = runParamscript_json['PC_RATING']['totalValidNum'];
                            }
                            //
                            /*let deliveryLayoutInfo = runParamscript_json['SHIPPING']['deliveryLayoutInfo'];
                            if(deliveryLayoutInfo.length > 0){
                                let shippingBizData = runParamscript_json['SHIPPING']['deliveryLayoutInfo'][0]['bizData'];
                                need_item['_shangjia_shippingFee'] = shippingBizData['formattedAmount'];
                                need_item['_shangjia_shippingFee_label'] = 'shipFrom:'+shippingBizData['shipFrom']+',shipTo:'+shippingBizData['shipTo']+',delivery:'+shippingBizData['displayEtaMinDate']+'-'+shippingBizData['displayEtaMaxDate'];
                            }*/
                            //
                            let sellerComponent = runParamscript_json['SHOP_CARD_PC']
                            let storeURL = sellerComponent['sellerInfo']['storeURL'];
                            storeURL = storeURL.replace('//','https://');
                            need_item['_shangjia_store_name'] = sellerComponent['storeName'];
                            need_item['_shangjia_store_url'] = storeURL;
                            need_item['_shangjia_store_items'] = '';
                            need_item['_shangjia_store_followers'] = '';
                            need_item['_shangjia_store_sold'] = '';
                            need_item['_shangjia_store_score'] = '';
                            need_item['_shangjia_store_country'] = '';
                            need_item['_shangjia_store_opentime'] = '';
                            //
                            let _shangjia_specifications = '';
                            if(runParamscript_json.hasOwnProperty('PRODUCT_PROP_PC')){
                                let productPropComponent = runParamscript_json['PRODUCT_PROP_PC'];
                                if(productPropComponent.hasOwnProperty('showedProps')){
                                    let props = productPropComponent['showedProps'];
                                    if(props.length > 0){
                                        for(let pi=0; pi<props.length; pi++){
                                            _shangjia_specifications+="<div class='specification--prop--RejitI8'><div class='specification--title--UbVeyic'><span>"+props[pi]['attrName']+"</span></div><div class='specification--desc--Mz148Bl'><span>"+props[pi]['attrValue']+"</span></div></div>";
                                        }
                                        _shangjia_specifications = "<div class='specification--list--fiWsSyv'>"+_shangjia_specifications+"</div>";
                                    }
                                }
                            }
                            need_item['_shangjia_specifications'] = _shangjia_specifications;
                            //
                            //
                            let descriptionUrl =  runParamscript_json['DESC']['pcDescUrl'];
                            //
                            let message = {
                                action: 'get_description',
                                url: descriptionUrl
                            };
                            chrome.runtime.sendMessage(message,(msg)=>{
                                console.log('get_description 答复',msg)
                                let msgobj  = JSON.parse(msg);
                                let description_data = msgobj['description'];
                                console.log('description_data');
                                console.log(description_data);
                                //
                                if(description_data){
                                    description_data = '<div>'+description_data+'</div>';
                                    description_data = description_data.replaceAll('(','');
                                    description_data = description_data.replaceAll(')','');
                                    let _description_data_dom = $(description_data);
                                    let _shangjia_productDetailFlatList = [];
                                    _description_data_dom.find('img').each(function () {
                                        _shangjia_productDetailFlatList.push($(this).attr('src'));
                                    })
                                    need_item['_shangjia_productDetailFlatList'] = _shangjia_productDetailFlatList;
                                    //
                                    need_item['_shangjia_goodsProperty'] = description_data.replace(/<a\s+href="[^"]*"/g, '<a href="#"');
                                    //
                                }
                                need_item['_is_request'] = 2;

                                //export csv
                                console.log('need_item');
                                console.log(need_item);
                                //
                                if(pingtai == 'shopify'){
                                    export_shopify_csv_output(need_item);
                                }else if(pingtai == 'tiktok'){
                                    export_tiktok_xlsx_output(need_item);
                                }else if(pingtai == 'normal'){
                                    export_normail_xlsx_output(need_item);
                                }
                                //
                            })
                            //
                        }else{
                            //alert('未获取到数据，请联系客服！');
                             setTimeout(function() {
                                        location.reload();
                                    }, 30000);
                        }
                        //
                    })
                    .catch(error => {
                        console.error(`Failed to fetch script ${script.name}:`, error);
                        setTimeout(function() {
                                        location.reload();
                                    }, 30000);
                    });
            });
        }
    }
}

function export_single(pingtai='shopify') {
    //判断是否过期
    let message = {
        action: 'check_expire'
    };
    chrome.runtime.sendMessage(message,(msg)=> {
        console.log('check_expire 答复', msg)
        let msgobj = JSON.parse(msg);
        console.log(msgobj['state']);
        let state = parseInt(msgobj['state']);
        if (state == 0) {//未过期
            //
           let current_url = window.location.href;
           let query_params = util_getCurrentUrlQueryStringParams();
           console.log('query_params');
           console.log(query_params);
           //
           if(query_params.hasOwnProperty('gypingtai') == false){
               if(current_url.indexOf('?')!=-1){
                   current_url+='&gypingtai='+pingtai;
               }else{
                   current_url+='?gypingtai='+pingtai;
               }
           }else{
               let current_url_arr = current_url.split('?');
               let current_url_temp = current_url_arr[0];
               current_url_temp+='?gypingtai='+pingtai;
               current_url = current_url_temp;
           }
           console.log('current_url');
           console.log(current_url);
           window.location.href = current_url;
        }else{
            $('.gycharm-tips').remove();
            let gycharm_tips = $("<div>", {
                class:'gycharm-tips',
                html: 'Aliexpress产品助手:产品采集插件，还未购买或者已过期，请<a href="https://www.gycharm.com/user/order-plugin?plugin=vip_aliexpress_1nian&type=other_plugin" target="_blank">Gycharm.com</a>官网购买或者续费！', // 按钮文本
                style: "display: block;\n" +
                    "    z-index: 999;\n" +
                    "    color: red;\n" +
                    "    padding-top: 20px;\n" +
                    "    margin-top: 20px;\n" +
                    "    border: 0;\n" +
                    "    line-height: 20px;\n" +
                    "    font-weight: bold;\n"
             });
            $('.pdp-info-left').append(gycharm_tips);
        }
    });
}

function ajax_get_reviews(){
    let query_params = util_getCurrentUrlQueryStringParams();
    if(query_params.hasOwnProperty('gyexportreview')){
        $('#gycharm-custom-msg').remove();
        let current_url = window.location.href;
        let current_url_arr = current_url.split('?');
        let _shangjia_about_contact_and_basic_info_link = current_url_arr[0];
        //
        let performanceData  = null;
        try{
            performanceData = window.performance;
        }catch  (error) {
            console.error("iframePerformance:", error);
        }
        if (performanceData!==null) {
            // 变量已定义
            // 获取网络请求条目
            let resources = performanceData.getEntriesByType('resource');
            // 筛选出类型为 script 且 src 包含特定字符串的条目
            const targetScripts = resources.filter(resource =>
                resource.initiatorType === "script" &&
                resource.name.includes("mtop.aliexpress.itemdetail.pc.asyncpcdetail")
            );
            // 获取并输出每个符合条件的 script 资源的内容
            targetScripts.forEach(script => {
                fetch(script.name,{ credentials: 'include' })
                    .then(response => response.text())
                    .then(content => {
                        console.log(`Content of script ${script.name}:`);
                        //console.log(content);
                        //
                        let runParamscript = content.replace('mtopjsonp1(','');
                        runParamscript = runParamscript.slice(0,-1);
                        console.log('runParamscript');
                        console.log(runParamscript);
                        //
                        let runParamscript_data_json = JSON.parse(runParamscript);
                        console.log(runParamscript_data_json);
                        let runParamscript_json = runParamscript_data_json['data']['data'];
                        if(runParamscript_json){
                            //
                            let _skus = runParamscript_json['priceComponent']['skuPriceList'];
                            let _item = runParamscript_json['productInfoComponent'];
                            let need_item = {
                                    '_shangjia_about_contact_and_basic_info_link_key':query_params['_shangjia_about_contact_and_basic_info_link_key'],
                                    '_shangjia_id': '',
                                    '_shangjia_about_contact_and_basic_info_link': _shangjia_about_contact_and_basic_info_link,

                                    '_shangjia_store_name': '',
                                    '_shangjia_store_url': '',
                                    '_shangjia_store_items': '',
                                    '_shangjia_store_followers': '',
                                    '_shangjia_store_sold': '',
                                    '_shangjia_store_score': '',
                                    //
                                    '_shangjia_goodsId': '', //sku
                                    '_shangjia_variants_skus': [], //数组
                                    '_shangjia_goodsName': '',
                                    '_shangjia_goodsProperty': '',//description,deschtml
                                    '_shangjia_minOnSalePriceStr': '', //最小价格,当没有属性时选择该价格
                                    '_shangjia_hdThumbUrl': '',//主图
                                    '_shangjia_gallery': [], //图片列表
                                    '_shangjia_productDetailFlatList': [],//details imgs
                                    '_shangjia_category': '',//brumb
                                    '_shangjia_VideoUrl': '', //video
                                    '_shangjia_shippingFee':'',
                                    '_shangjia_specifications':''
                                    //
                            };
                            let _shangjia_variants_skus = [];
                            if(_skus && _skus.length > 0){
                                if(runParamscript_json['skuComponent']['hasSkuProperty']){
                                    //
                                    let _productSKUPropertyList = runParamscript_json['skuComponent']['productSKUPropertyList'];
                                    //
                                    for(let _i=0;_i<_skus.length;_i++){
                                        //
                                        let specs_key1_name = '';
                                        let specs_key1_value = '';
                                        let specs_key2_name = '';
                                        let specs_key2_value = '';
                                        let specs_key3_name = '';
                                        let specs_key3_value = '';
                                        let specs_key4_name = '';
                                        let specs_key4_value = '';
                                        let _attr_img = '';
                                        //
                                        let skuAttr = _skus[_i]['skuAttr'];
                                        let skuAttrArr = skuAttr.split(';');

                                        //
                                        let skuAttrArrLength = skuAttrArr.length;

                                        if(_productSKUPropertyList[_productSKUPropertyList.length-1]['skuPropertyName'] =="Ships From"){
                                            skuAttrArrLength = skuAttrArrLength-1;
                                        }
                                        //

                                        if(skuAttrArrLength == 1){
                                            let _attr_value = skuAttrArr[0];
                                            let _attr_value_arr = _attr_value.split(':');
                                            let _attr_name_id = _attr_value_arr[0];
                                            let _attr_value_id = _attr_value_arr[1];
                                            let attr_name_value_arr = util_get_attr_name_value(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key1_name = attr_name_value_arr['_attr_name'];
                                            specs_key1_value = attr_name_value_arr['_attr_value_name'];
                                            if(_attr_img == '' && attr_name_value_arr['_attr_img']){
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                        }else if(skuAttrArrLength == 2){
                                            let _attr_value = skuAttrArr[0];
                                            let _attr_value_arr = _attr_value.split(':');
                                            let _attr_name_id = _attr_value_arr[0];
                                            let _attr_value_id = _attr_value_arr[1];
                                            let attr_name_value_arr = util_get_attr_name_value(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key1_name = attr_name_value_arr['_attr_name'];
                                            specs_key1_value = attr_name_value_arr['_attr_value_name'];
                                            if(_attr_img == '' && attr_name_value_arr['_attr_img']){
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                            _attr_value = skuAttrArr[1];
                                            _attr_value_arr = _attr_value.split(':');
                                            _attr_name_id = _attr_value_arr[0];
                                            _attr_value_id = _attr_value_arr[1];
                                            attr_name_value_arr = util_get_attr_name_value(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key2_name = attr_name_value_arr['_attr_name'];
                                            specs_key2_value = attr_name_value_arr['_attr_value_name'];
                                            if(_attr_img == '' && attr_name_value_arr['_attr_img']){
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                        }else if(skuAttrArrLength == 3){
                                            let _attr_value = skuAttrArr[0];
                                            let _attr_value_arr = _attr_value.split(':');
                                            let _attr_name_id = _attr_value_arr[0];
                                            let _attr_value_id = _attr_value_arr[1];
                                            let attr_name_value_arr = util_get_attr_name_value(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key1_name = attr_name_value_arr['_attr_name'];
                                            specs_key1_value = attr_name_value_arr['_attr_value_name'];
                                            if(_attr_img == '' && attr_name_value_arr['_attr_img']){
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                            _attr_value = skuAttrArr[1];
                                            _attr_value_arr = _attr_value.split(':');
                                            _attr_name_id = _attr_value_arr[0];
                                            _attr_value_id = _attr_value_arr[1];
                                            attr_name_value_arr = util_get_attr_name_value(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key2_name = attr_name_value_arr['_attr_name'];
                                            specs_key2_value = attr_name_value_arr['_attr_value_name'];
                                            if(_attr_img == '' && attr_name_value_arr['_attr_img']){
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                            _attr_value = skuAttrArr[2];
                                            _attr_value_arr = _attr_value.split(':');
                                            _attr_name_id = _attr_value_arr[0];
                                            _attr_value_id = _attr_value_arr[1];
                                            attr_name_value_arr = util_get_attr_name_value(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key3_name = attr_name_value_arr['_attr_name'];
                                            specs_key3_value = attr_name_value_arr['_attr_value_name'];
                                            if(_attr_img == '' && attr_name_value_arr['_attr_img']){
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                        }else if(skuAttrArrLength == 4){
                                            let _attr_value = skuAttrArr[0];
                                            let _attr_value_arr = _attr_value.split(':');
                                            let _attr_name_id = _attr_value_arr[0];
                                            let _attr_value_id = _attr_value_arr[1];
                                            let attr_name_value_arr = util_get_attr_name_value(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key1_name = attr_name_value_arr['_attr_name'];
                                            specs_key1_value = attr_name_value_arr['_attr_value_name'];
                                            if(_attr_img == '' && attr_name_value_arr['_attr_img']){
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                            _attr_value = skuAttrArr[1];
                                            _attr_value_arr = _attr_value.split(':');
                                            _attr_name_id = _attr_value_arr[0];
                                            _attr_value_id = _attr_value_arr[1];
                                            attr_name_value_arr = util_get_attr_name_value(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key2_name = attr_name_value_arr['_attr_name'];
                                            specs_key2_value = attr_name_value_arr['_attr_value_name'];
                                            if(_attr_img == '' && attr_name_value_arr['_attr_img']){
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                            _attr_value = skuAttrArr[2];
                                            _attr_value_arr = _attr_value.split(':');
                                            _attr_name_id = _attr_value_arr[0];
                                            _attr_value_id = _attr_value_arr[1];
                                            attr_name_value_arr = util_get_attr_name_value(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key3_name = attr_name_value_arr['_attr_name'];
                                            specs_key3_value = attr_name_value_arr['_attr_value_name'];
                                            if(_attr_img == '' && attr_name_value_arr['_attr_img']){
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                            _attr_value = skuAttrArr[3];
                                            _attr_value_arr = _attr_value.split(':');
                                            _attr_name_id = _attr_value_arr[0];
                                            _attr_value_id = _attr_value_arr[1];
                                            attr_name_value_arr = util_get_attr_name_value(_productSKUPropertyList, _attr_name_id, _attr_value_id);
                                            specs_key4_name = attr_name_value_arr['_attr_name'];
                                            specs_key4_value = attr_name_value_arr['_attr_value_name'];
                                            if(_attr_img == '' && attr_name_value_arr['_attr_img']){
                                                _attr_img = attr_name_value_arr['_attr_img'];
                                            }
                                            //
                                        }
                                        //
                                        let _skuVal = _skus[_i]['skuVal'];
                                        let normalPriceStr = _skus[_i]['skuVal']['skuAmount']['formatedAmount'];
                                        if(_skuVal.hasOwnProperty('skuActivityAmount')){
                                            normalPriceStr = _skus[_i]['skuVal']['skuActivityAmount']['formatedAmount'];
                                        }
                                        //
                                        _shangjia_variants_skus.push({
                                            'subsku': _item['id']+specs_key1_value+specs_key2_value+specs_key3_value+specs_key4_value,
                                            'normalPriceStr': normalPriceStr,
                                            'normalLinePriceStr':_skus[_i]['skuVal']['skuAmount']['formatedAmount'],
                                            'img':_attr_img,
                                            'specs_key1_name':specs_key1_name,
                                            'specs_key1_value':specs_key1_value,
                                            'specs_key2_name':specs_key2_name,
                                            'specs_key2_value':specs_key2_value,
                                            'specs_key3_name':specs_key3_name,
                                            'specs_key3_value':specs_key3_value,
                                            'specs_key4_name':specs_key4_name,
                                            'specs_key4_value':specs_key4_value,
                                            'stockQuantity': _skus[_i]['skuVal']['inventory'],
                                            'skuId': _skus[_i]['skuId']
                                        });
                                        //
                                    }
                                    //
                                }else{
                                    //没有属性
                                    let _sku = _skus[0];
                                    let _skuVal = _sku['skuVal'];
                                    let normalPriceStr = _sku['skuVal']['skuAmount']['formatedAmount'];
                                    if(_skuVal.hasOwnProperty('skuActivityAmount')){
                                        normalPriceStr = _sku['skuVal']['skuActivityAmount']['formatedAmount'];
                                    }
                                    _shangjia_variants_skus.push({
                                        'subsku': _item['id'],
                                        'normalPriceStr': normalPriceStr,
                                        'normalLinePriceStr':_sku['skuVal']['skuAmount']['formatedAmount'],
                                        'img':'',
                                        'specs_key1_name':'',
                                        'specs_key1_value':'',
                                        'specs_key2_name':'',
                                        'specs_key2_value':'',
                                        'specs_key3_name':'',
                                        'specs_key3_value':'',
                                        'specs_key4_name':'',
                                        'specs_key4_value':'',
                                        'stockQuantity': _sku['skuVal']['inventory'],
                                        'skuId': _item['id']
                                    });
                                    //
                                }
                            }
                            need_item['_shangjia_variants_skus'] = _shangjia_variants_skus;
                            //
                            need_item['_shangjia_goodsId'] = _item['id'];
                            need_item['_shangjia_goodsName'] = _item['subject'];
                            need_item['_shangjia_minOnSalePriceStr'] = _item['minPrice'];
                            //
                            let _shangjia_VideoUrl = '';
                            let _shangjia_gallery = runParamscript_json['imageComponent']['imagePathList'];
                            need_item['_shangjia_gallery'] = _shangjia_gallery;
                            if(_shangjia_gallery.length > 0){
                                need_item['_shangjia_hdThumbUrl'] = _shangjia_gallery[0];
                            }
                            need_item['_shangjia_VideoUrl'] = _shangjia_VideoUrl;
                            //
                            need_item['_shangjia_category'] = '';
                            need_item['_shangjia_sold'] = runParamscript_json['tradeComponent']['formatTradeCount'];
                            need_item['_shangjia_reivew_num'] = runParamscript_json['feedbackComponent']['totalValidNum'];
                            need_item['_shangjia_shippingFee'] = runParamscript_json['webGeneralFreightCalculateComponent']['shippingFeeText'];
                            //
                            let _shangjia_specifications = '';
                            if(runParamscript_json.hasOwnProperty('productPropComponent')){
                                let productPropComponent = runParamscript_json['productPropComponent'];
                                if(productPropComponent.hasOwnProperty('props')){
                                    let props = productPropComponent['props'];
                                    if(props.length > 0){
                                        for(let pi=0; pi<props.length; pi++){
                                            _shangjia_specifications+="<div class='specification--prop--RejitI8'><div class='specification--title--UbVeyic'><span>"+props[pi]['attrName']+"</span></div><div class='specification--desc--Mz148Bl'><span>"+props[pi]['attrValue']+"</span></div></div>";
                                        }
                                        _shangjia_specifications = "<div class='specification--list--fiWsSyv'>"+_shangjia_specifications+"</div>";
                                    }
                                }
                            }
                            need_item['_shangjia_specifications'] = _shangjia_specifications;
                            //
                            let sellerComponent = runParamscript_json['sellerComponent'];
                            let storeURL = sellerComponent['storeURL'];
                            storeURL = storeURL.replace('//','https://');
                            need_item['_shangjia_store_name'] = sellerComponent['storeName'];
                            need_item['_shangjia_store_url'] = storeURL;
                            need_item['_shangjia_store_items'] = '';
                            need_item['_shangjia_store_followers'] = '';
                            need_item['_shangjia_store_sold'] = '';
                            need_item['_shangjia_store_score'] = '';
                            need_item['_shangjia_store_country'] = sellerComponent['countryCompleteName'];
                            need_item['_shangjia_store_opentime'] = sellerComponent['formatOpenTime'];
                            //
                            let descriptionUrl =  runParamscript_json['productDescComponent']['descriptionUrl'];
                            //
                            let message = {
                                action: 'get_description',
                                url: descriptionUrl
                            };
                            chrome.runtime.sendMessage(message,(msg)=>{
                                console.log('get_description 答复',msg)
                                let msgobj  = JSON.parse(msg);
                                let description_data = msgobj['description'];
                                console.log('description_data');
                                console.log(description_data);
                                //
                                if(description_data){
                                    description_data = '<div>'+description_data+'</div>';
                                    description_data = description_data.replaceAll('(','');
                                    description_data = description_data.replaceAll(')','');
                                    let _description_data_dom = $(description_data);
                                    let _shangjia_productDetailFlatList = [];
                                    _description_data_dom.find('img').each(function () {
                                        _shangjia_productDetailFlatList.push($(this).attr('src'));
                                    })
                                    need_item['_shangjia_productDetailFlatList'] = _shangjia_productDetailFlatList;
                                    //
                                    need_item['_shangjia_goodsProperty'] = description_data.replace(/<a\s+href="[^"]*"/g, '<a href="#"');
                                    //
                                }
                                need_item['_is_request'] = 2;

                                //export csv
                                console.log('need_item');
                                console.log(need_item);
                                //
                                if(pingtai == 'shopify'){
                                    export_shopify_csv_output(need_item);
                                }else if(pingtai == 'tiktok'){
                                    export_tiktok_xlsx_output(need_item);
                                }else if(pingtai == 'normal'){
                                    export_normail_xlsx_output(need_item);
                                }
                                //
                            })
                        }else{
                            //alert('未获取到数据，请联系客服！');
                             setTimeout(function() {
                                        location.reload();
                                    }, 30000);
                        }
                        //
                    })
                    .catch(error => {
                        console.error(`Failed to fetch script ${script.name}:`, error);
                        setTimeout(function() {
                                        location.reload();
                                    }, 30000);
                    });
            });
        }
    }
}

function extract_product_review_bak(){
    //
    let res = {
        'reviews_data':[],
        'product_id':''
    };
    console.log('aaaa');
    let runParamscript = util_getscript_pageData_content($('html').html());
    console.log('runParamscript a1');
    if(runParamscript) {
        runParamscript = runParamscript.trim();
        runParamscript = runParamscript.replace('window.runParams =', '')
            .replace('window.runParams.is23 = true;', '');
        runParamscript = runParamscript.trim();
        runParamscript = runParamscript.slice(0, -1);
        //
        let runParamscript_arr = runParamscript.split('data:');
        runParamscript = runParamscript_arr[1];
        runParamscript = runParamscript.slice(0, -1);
        runParamscript = runParamscript.trim();
        //
        console.log('runParamscript');
        //console.log(runParamscript);
        let runParamscript_json = JSON.parse(runParamscript);
        console.log(runParamscript_json);
        //
        if (runParamscript_json) {
            //
            let _item = runParamscript_json['productInfoComponent'];
            res['product_id'] = _item['id'];
            let _review_url = 'https://feedback.aliexpress.com/pc/searchEvaluation.do?productId='+_item['id']+'&lang=en_US&country=US&page=1&pageSize=100&filter=all&sort=complex_default';
            let _reviews = ajax_get_reviews(_review_url);
            if(_reviews){
                let _reviews_json = JSON.parse(_reviews);
                console.log('_reviews_json');
                console.log(_reviews_json);
                //
                let reviews_data = [];
                if(_reviews_json['data']['totalNum'] >0){
                    //
                    let evaViewList = _reviews_json['data']['evaViewList'];
                    for(let r=0;r<evaViewList.length;r++){
                        reviews_data.push(evaViewList[r]);
                    }
                    //
                    let _total_page = _reviews_json['data']['totalPage'];
                    for(let i=2;i<=_total_page;i++){
                         _review_url = 'https://feedback.aliexpress.com/pc/searchEvaluation.do?productId='+_item['id']+'&lang=en_US&country=US&page='+i+'&pageSize=100&filter=all&sort=complex_default';
                         console.log('_review_url:'+_review_url);
                         _reviews = ajax_get_reviews(_review_url);
                         if(_reviews) {
                             let _reviews_json = JSON.parse(_reviews);
                             let evaViewList = _reviews_json['data']['evaViewList'];
                             for(let r=0;r<evaViewList.length;r++){
                                reviews_data.push(evaViewList[r]);
                             }
                         }
                        //
                        utrl_someTimeConsumingOperation(2000);
                        //
                    }
                    //
                    res['reviews_data'] = reviews_data;
                }
                //
            }
        }
    }
    console.log('res');
    console.log(res);
    //
    let reviews = [];
    let product_id = res['product_id'];
    let reviews_data = res['reviews_data'];
    if(reviews_data.length > 0){
        for(let i=0;i<reviews_data.length;i++){
            let images_arr = reviews_data[i]['images'];
            let images = '';
            if(images_arr && images_arr.length>0){
                images = images_arr.join('|');
            }
            let review = {
                'buyerName': reviews_data[i]['buyerName'],
                'evalDate': reviews_data[i]['evalDate'],
                'buyerEval':reviews_data[i]['buyerEval'],
                'buyerCountry':reviews_data[i]['buyerCountry'],
                'skuInfo': reviews_data[i]['skuInfo'],
                'buyerFeedback':reviews_data[i]['buyerFeedback'],
                'images':images
            }
            reviews.push(review);
        }
        //
        exportToCsv(reviews, 'gycharm-aliexpress-review-export-'+product_id+'-'+Date.now(), "Sheet1");
    }else{
        alert('该商品没有评论！');
    }
    //
    return res;
    //
}

function extract_product_review(){
    let query_params = util_getCurrentUrlQueryStringParams();
    if(query_params.hasOwnProperty('gyexportreview')){
        $('#gycharm-custom-msg').remove();
        let current_url = window.location.href;
        let current_url_arr = current_url.split('?');
        let _shangjia_about_contact_and_basic_info_link = current_url_arr[0];
        //
        let performanceData  = null;
        try{
            performanceData = window.performance;
        }catch  (error) {
            console.error("iframePerformance:", error);
        }
        if (performanceData!==null) {
            // 变量已定义
            // 获取网络请求条目
            let resources = performanceData.getEntriesByType('resource');
            // 筛选出类型为 script 且 src 包含特定字符串的条目
            const targetScripts = resources.filter(resource =>
                resource.initiatorType === "script" &&
                resource.name.includes("mtop.aliexpress.itemdetail.pc.asyncpcdetail")
            );
            // 获取并输出每个符合条件的 script 资源的内容
            targetScripts.forEach(script => {
                fetch(script.name,{ credentials: 'include' })
                    .then(response => response.text())
                    .then(content => {
                        console.log(`Content of script ${script.name}:`);
                        //console.log(content);
                        //
                        let runParamscript = content.replace('mtopjsonp1(','');
                        runParamscript = runParamscript.slice(0,-1);
                        console.log('runParamscript');
                        console.log(runParamscript);
                        //
                        let runParamscript_data_json = JSON.parse(runParamscript);
                        console.log(runParamscript_data_json);
                        let runParamscript_json = runParamscript_data_json['data']['data'];
                        if(runParamscript_json){
                             //
                            let res = {
                                'reviews_data':[],
                                'product_id':''
                            };
                            //
                            let _item = runParamscript_json['productInfoComponent'];
                            res['product_id'] = _item['id'];
                            let _review_url = 'https://feedback.aliexpress.com/pc/searchEvaluation.do?productId='+_item['id']+'&lang=en_US&country=US&page=1&pageSize=100&filter=all&sort=complex_default';
                            let _reviews = ajax_get_reviews(_review_url);
                            if(_reviews){
                                let _reviews_json = JSON.parse(_reviews);
                                console.log('_reviews_json');
                                console.log(_reviews_json);
                                //
                                let reviews_data = [];
                                if(_reviews_json['data']['totalNum'] >0){
                                    //
                                    let evaViewList = _reviews_json['data']['evaViewList'];
                                    for(let r=0;r<evaViewList.length;r++){
                                        reviews_data.push(evaViewList[r]);
                                    }
                                    //
                                    let _total_page = _reviews_json['data']['totalPage'];
                                    for(let i=2;i<=_total_page;i++){
                                         _review_url = 'https://feedback.aliexpress.com/pc/searchEvaluation.do?productId='+_item['id']+'&lang=en_US&country=US&page='+i+'&pageSize=100&filter=all&sort=complex_default';
                                         console.log('_review_url:'+_review_url);
                                         _reviews = ajax_get_reviews(_review_url);
                                         if(_reviews) {
                                             let _reviews_json = JSON.parse(_reviews);
                                             let evaViewList = _reviews_json['data']['evaViewList'];
                                             for(let r=0;r<evaViewList.length;r++){
                                                reviews_data.push(evaViewList[r]);
                                             }
                                         }
                                        //
                                        utrl_someTimeConsumingOperation(2000);
                                        //
                                    }
                                    //
                                    res['reviews_data'] = reviews_data;
                                }
                                //
                            }
                            console.log('res');
                            console.log(res);
                            //
                            let reviews = [];
                            let product_id = res['product_id'];
                            let reviews_data = res['reviews_data'];
                            if(reviews_data.length > 0){
                                for(let i=0;i<reviews_data.length;i++){
                                    let images_arr = reviews_data[i]['images'];
                                    let images = '';
                                    if(images_arr && images_arr.length>0){
                                        images = images_arr.join('|');
                                    }
                                    let review = {
                                        'buyerName': reviews_data[i]['buyerName'],
                                        'evalDate': reviews_data[i]['evalDate'],
                                        'buyerEval':reviews_data[i]['buyerEval'],
                                        'buyerCountry':reviews_data[i]['buyerCountry'],
                                        'skuInfo': reviews_data[i]['skuInfo'],
                                        'buyerFeedback':reviews_data[i]['buyerFeedback'],
                                        'images':images
                                    }
                                    reviews.push(review);
                                }
                                //
                                exportToCsv(reviews, 'gycharm-aliexpress-review-export-'+product_id+'-'+Date.now(), "Sheet1");
                            }else{
                                alert('该商品没有评论！');
                            }
                            //
                            return res;
                            //
                            //
                        }else{
                            //alert('未获取到数据，请联系客服！');
                             setTimeout(function() {
                                        location.reload();
                                    }, 30000);
                        }
                        //
                    })
                    .catch(error => {
                        console.error(`Failed to fetch script ${script.name}:`, error);
                        setTimeout(function() {
                                        location.reload();
                                    }, 30000);
                    });
            });
        }
    }
}

// get popup2content info
chrome.runtime.onMessage.addListener((request, sender, sendResponse) => {
    if(request.action == 'extract-product-lunbo-imgs'){
        console.log(request.info);
        catalog_products_url = get_product_lunbo_imgs();
        sendResponse(catalog_products_url);
    }else if(request.action == 'extract-product-details-imgs'){
        console.log(request.info);
        catalog_products_url = get_product_details_imgs();
        sendResponse(catalog_products_url);
    }else if(request.action == 'extract_products_lunbo_imgs'){
        console.log(request.info);
        catalog_products_url = extract_products_lunbo_imgs(request.galleryimgs);
        sendResponse(catalog_products_url);
    }else if(request.action == 'extract_products_detail_imgs'){
        console.log(request.info);
        catalog_products_url = extract_products_detail_imgs(request.detailsimgs);
        sendResponse(catalog_products_url);
    }
})
//